#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::DCKCFGR {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `TIMPRE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TIMPRER {
    #[doc = "If the APB prescaler is configured 1, TIMxCLK = PCLKx. Otherwise, TIMxCLK = 2xPCLKx"]
    MUL2,
    #[doc = "If the APB prescaler is configured 1, 2 or 4, TIMxCLK = HCLK. Otherwise, TIMxCLK = 4xPCLKx"]
    MUL4,
}
impl TIMPRER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            TIMPRER::MUL2 => false,
            TIMPRER::MUL4 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> TIMPRER {
        match value {
            false => TIMPRER::MUL2,
            true => TIMPRER::MUL4,
        }
    }
    #[doc = "Checks if the value of the field is `MUL2`"]
    #[inline]
    pub fn is_mul2(&self) -> bool {
        *self == TIMPRER::MUL2
    }
    #[doc = "Checks if the value of the field is `MUL4`"]
    #[inline]
    pub fn is_mul4(&self) -> bool {
        *self == TIMPRER::MUL4
    }
}
#[doc = "Possible values of the field `I2SSRC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum I2SSRCR {
    #[doc = "I2Sx clock frequency = f(PLLCLK_R)"]
    PLLCLKR,
    #[doc = "I2Sx clock frequency = I2S_CKIN Alternate function input frequency"]
    I2S_CKIN,
    #[doc = "I2Sx clock frequency = HSI/HSE depends on PLLSRC bit (PLLCFGR\\[22\\])"]
    HSI_HSE,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl I2SSRCR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            I2SSRCR::PLLCLKR => 0,
            I2SSRCR::I2S_CKIN => 1,
            I2SSRCR::HSI_HSE => 3,
            I2SSRCR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> I2SSRCR {
        match value {
            0 => I2SSRCR::PLLCLKR,
            1 => I2SSRCR::I2S_CKIN,
            3 => I2SSRCR::HSI_HSE,
            i => I2SSRCR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `PLLCLKR`"]
    #[inline]
    pub fn is_pllclkr(&self) -> bool {
        *self == I2SSRCR::PLLCLKR
    }
    #[doc = "Checks if the value of the field is `I2S_CKIN`"]
    #[inline]
    pub fn is_i2s_ckin(&self) -> bool {
        *self == I2SSRCR::I2S_CKIN
    }
    #[doc = "Checks if the value of the field is `HSI_HSE`"]
    #[inline]
    pub fn is_hsi_hse(&self) -> bool {
        *self == I2SSRCR::HSI_HSE
    }
}
#[doc = "Values that can be written to the field `TIMPRE`"]
pub enum TIMPREW {
    #[doc = "If the APB prescaler is configured 1, TIMxCLK = PCLKx. Otherwise, TIMxCLK = 2xPCLKx"]
    MUL2,
    #[doc = "If the APB prescaler is configured 1, 2 or 4, TIMxCLK = HCLK. Otherwise, TIMxCLK = 4xPCLKx"]
    MUL4,
}
impl TIMPREW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            TIMPREW::MUL2 => false,
            TIMPREW::MUL4 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _TIMPREW<'a> {
    w: &'a mut W,
}
impl<'a> _TIMPREW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: TIMPREW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "If the APB prescaler is configured 1, TIMxCLK = PCLKx. Otherwise, TIMxCLK = 2xPCLKx"]
    #[inline]
    pub fn mul2(self) -> &'a mut W {
        self.variant(TIMPREW::MUL2)
    }
    #[doc = "If the APB prescaler is configured 1, 2 or 4, TIMxCLK = HCLK. Otherwise, TIMxCLK = 4xPCLKx"]
    #[inline]
    pub fn mul4(self) -> &'a mut W {
        self.variant(TIMPREW::MUL4)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 24;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `I2SSRC`"]
pub enum I2SSRCW {
    #[doc = "I2Sx clock frequency = f(PLLCLK_R)"]
    PLLCLKR,
    #[doc = "I2Sx clock frequency = I2S_CKIN Alternate function input frequency"]
    I2S_CKIN,
    #[doc = "I2Sx clock frequency = HSI/HSE depends on PLLSRC bit (PLLCFGR\\[22\\])"]
    HSI_HSE,
}
impl I2SSRCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            I2SSRCW::PLLCLKR => 0,
            I2SSRCW::I2S_CKIN => 1,
            I2SSRCW::HSI_HSE => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _I2SSRCW<'a> {
    w: &'a mut W,
}
impl<'a> _I2SSRCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: I2SSRCW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "I2Sx clock frequency = f(PLLCLK_R)"]
    #[inline]
    pub fn pllclkr(self) -> &'a mut W {
        self.variant(I2SSRCW::PLLCLKR)
    }
    #[doc = "I2Sx clock frequency = I2S_CKIN Alternate function input frequency"]
    #[inline]
    pub fn i2s_ckin(self) -> &'a mut W {
        self.variant(I2SSRCW::I2S_CKIN)
    }
    #[doc = "I2Sx clock frequency = HSI/HSE depends on PLLSRC bit (PLLCFGR\\[22\\])"]
    #[inline]
    pub fn hsi_hse(self) -> &'a mut W {
        self.variant(I2SSRCW::HSI_HSE)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 25;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 24 - TIMPRE"]
    #[inline]
    pub fn timpre(&self) -> TIMPRER {
        TIMPRER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 24;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bits 25:26 - I2SSRC"]
    #[inline]
    pub fn i2ssrc(&self) -> I2SSRCR {
        I2SSRCR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 25;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 24 - TIMPRE"]
    #[inline]
    pub fn timpre(&mut self) -> _TIMPREW {
        _TIMPREW { w: self }
    }
    #[doc = "Bits 25:26 - I2SSRC"]
    #[inline]
    pub fn i2ssrc(&mut self) -> _I2SSRCW {
        _I2SSRCW { w: self }
    }
}
