#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::DCKCFGR2 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `I2C4SEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum I2C4SELR {
    #[doc = "APB1 clock (PCLK1) is selected as I2C clock"]
    APB1,
    #[doc = "System clock is selected as I2C clock"]
    SYSCLK,
    #[doc = "HSI clock is selected as I2C clock"]
    HSI,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl I2C4SELR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            I2C4SELR::APB1 => 0,
            I2C4SELR::SYSCLK => 1,
            I2C4SELR::HSI => 2,
            I2C4SELR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> I2C4SELR {
        match value {
            0 => I2C4SELR::APB1,
            1 => I2C4SELR::SYSCLK,
            2 => I2C4SELR::HSI,
            i => I2C4SELR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `APB1`"]
    #[inline]
    pub fn is_apb1(&self) -> bool {
        *self == I2C4SELR::APB1
    }
    #[doc = "Checks if the value of the field is `SYSCLK`"]
    #[inline]
    pub fn is_sysclk(&self) -> bool {
        *self == I2C4SELR::SYSCLK
    }
    #[doc = "Checks if the value of the field is `HSI`"]
    #[inline]
    pub fn is_hsi(&self) -> bool {
        *self == I2C4SELR::HSI
    }
}
#[doc = "Possible values of the field `LPTIM1SEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum LPTIM1SELR {
    #[doc = "APB1 clock (PCLK1) selected as LPTILM1 clock"]
    APB1,
    #[doc = "LSI clock is selected as LPTILM1 clock"]
    LSI,
    #[doc = "HSI clock is selected as LPTILM1 clock"]
    HSI,
    #[doc = "LSE clock is selected as LPTILM1 clock"]
    LSE,
}
impl LPTIM1SELR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            LPTIM1SELR::APB1 => 0,
            LPTIM1SELR::LSI => 1,
            LPTIM1SELR::HSI => 2,
            LPTIM1SELR::LSE => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> LPTIM1SELR {
        match value {
            0 => LPTIM1SELR::APB1,
            1 => LPTIM1SELR::LSI,
            2 => LPTIM1SELR::HSI,
            3 => LPTIM1SELR::LSE,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `APB1`"]
    #[inline]
    pub fn is_apb1(&self) -> bool {
        *self == LPTIM1SELR::APB1
    }
    #[doc = "Checks if the value of the field is `LSI`"]
    #[inline]
    pub fn is_lsi(&self) -> bool {
        *self == LPTIM1SELR::LSI
    }
    #[doc = "Checks if the value of the field is `HSI`"]
    #[inline]
    pub fn is_hsi(&self) -> bool {
        *self == LPTIM1SELR::HSI
    }
    #[doc = "Checks if the value of the field is `LSE`"]
    #[inline]
    pub fn is_lse(&self) -> bool {
        *self == LPTIM1SELR::LSE
    }
}
#[doc = "Values that can be written to the field `I2C4SEL`"]
pub enum I2C4SELW {
    #[doc = "APB1 clock (PCLK1) is selected as I2C clock"]
    APB1,
    #[doc = "System clock is selected as I2C clock"]
    SYSCLK,
    #[doc = "HSI clock is selected as I2C clock"]
    HSI,
}
impl I2C4SELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            I2C4SELW::APB1 => 0,
            I2C4SELW::SYSCLK => 1,
            I2C4SELW::HSI => 2,
        }
    }
}
#[doc = r" Proxy"]
pub struct _I2C4SELW<'a> {
    w: &'a mut W,
}
impl<'a> _I2C4SELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: I2C4SELW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "APB1 clock (PCLK1) is selected as I2C clock"]
    #[inline]
    pub fn apb1(self) -> &'a mut W {
        self.variant(I2C4SELW::APB1)
    }
    #[doc = "System clock is selected as I2C clock"]
    #[inline]
    pub fn sysclk(self) -> &'a mut W {
        self.variant(I2C4SELW::SYSCLK)
    }
    #[doc = "HSI clock is selected as I2C clock"]
    #[inline]
    pub fn hsi(self) -> &'a mut W {
        self.variant(I2C4SELW::HSI)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 22;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `LPTIM1SEL`"]
pub enum LPTIM1SELW {
    #[doc = "APB1 clock (PCLK1) selected as LPTILM1 clock"]
    APB1,
    #[doc = "LSI clock is selected as LPTILM1 clock"]
    LSI,
    #[doc = "HSI clock is selected as LPTILM1 clock"]
    HSI,
    #[doc = "LSE clock is selected as LPTILM1 clock"]
    LSE,
}
impl LPTIM1SELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            LPTIM1SELW::APB1 => 0,
            LPTIM1SELW::LSI => 1,
            LPTIM1SELW::HSI => 2,
            LPTIM1SELW::LSE => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _LPTIM1SELW<'a> {
    w: &'a mut W,
}
impl<'a> _LPTIM1SELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: LPTIM1SELW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "APB1 clock (PCLK1) selected as LPTILM1 clock"]
    #[inline]
    pub fn apb1(self) -> &'a mut W {
        self.variant(LPTIM1SELW::APB1)
    }
    #[doc = "LSI clock is selected as LPTILM1 clock"]
    #[inline]
    pub fn lsi(self) -> &'a mut W {
        self.variant(LPTIM1SELW::LSI)
    }
    #[doc = "HSI clock is selected as LPTILM1 clock"]
    #[inline]
    pub fn hsi(self) -> &'a mut W {
        self.variant(LPTIM1SELW::HSI)
    }
    #[doc = "LSE clock is selected as LPTILM1 clock"]
    #[inline]
    pub fn lse(self) -> &'a mut W {
        self.variant(LPTIM1SELW::LSE)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 30;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 22:23 - I2C4SEL"]
    #[inline]
    pub fn i2c4sel(&self) -> I2C4SELR {
        I2C4SELR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 22;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 30:31 - LPTIM1SEL"]
    #[inline]
    pub fn lptim1sel(&self) -> LPTIM1SELR {
        LPTIM1SELR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 30;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 22:23 - I2C4SEL"]
    #[inline]
    pub fn i2c4sel(&mut self) -> _I2C4SELW {
        _I2C4SELW { w: self }
    }
    #[doc = "Bits 30:31 - LPTIM1SEL"]
    #[inline]
    pub fn lptim1sel(&mut self) -> _LPTIM1SELW {
        _LPTIM1SELW { w: self }
    }
}
