#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::DCKCFGR {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `CKDFSDM1ASEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CKDFSDM1ASELR {
    #[doc = "CK_I2S_APB1 selected as audio clock"]
    I2S1,
    #[doc = "CK_I2S_APB2 selected as audio clock"]
    I2S2,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl CKDFSDM1ASELR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            CKDFSDM1ASELR::I2S1 => 0,
            CKDFSDM1ASELR::I2S2 => 1,
            CKDFSDM1ASELR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> CKDFSDM1ASELR {
        match value {
            0 => CKDFSDM1ASELR::I2S1,
            1 => CKDFSDM1ASELR::I2S2,
            i => CKDFSDM1ASELR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `I2S1`"]
    #[inline]
    pub fn is_i2s1(&self) -> bool {
        *self == CKDFSDM1ASELR::I2S1
    }
    #[doc = "Checks if the value of the field is `I2S2`"]
    #[inline]
    pub fn is_i2s2(&self) -> bool {
        *self == CKDFSDM1ASELR::I2S2
    }
}
#[doc = "Possible values of the field `TIMPRE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TIMPRER {
    #[doc = "If the APB prescaler is configured 1, TIMxCLK = PCLKx. Otherwise, TIMxCLK = 2xPCLKx"]
    MUL2,
    #[doc = "If the APB prescaler is configured 1, 2 or 4, TIMxCLK = HCLK. Otherwise, TIMxCLK = 4xPCLKx"]
    MUL4,
}
impl TIMPRER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            TIMPRER::MUL2 => false,
            TIMPRER::MUL4 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> TIMPRER {
        match value {
            false => TIMPRER::MUL2,
            true => TIMPRER::MUL4,
        }
    }
    #[doc = "Checks if the value of the field is `MUL2`"]
    #[inline]
    pub fn is_mul2(&self) -> bool {
        *self == TIMPRER::MUL2
    }
    #[doc = "Checks if the value of the field is `MUL4`"]
    #[inline]
    pub fn is_mul4(&self) -> bool {
        *self == TIMPRER::MUL4
    }
}
#[doc = "Possible values of the field `I2S1SRC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum I2S1SRCR {
    #[doc = "I2Sx clock frequency = f(PLLI2S_R)"]
    PLLI2SR,
    #[doc = "I2Sx clock frequency = I2S_CKIN Alternate function input frequency"]
    I2S_CKIN,
    #[doc = "I2Sx clock frequency = f(PLL_R)"]
    PLLR,
    #[doc = "I2Sx clock frequency = HSI/HSE depends on PLLSRC bit (PLLCFGR\\[22\\])"]
    HSI_HSE,
}
impl I2S1SRCR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            I2S1SRCR::PLLI2SR => 0,
            I2S1SRCR::I2S_CKIN => 1,
            I2S1SRCR::PLLR => 2,
            I2S1SRCR::HSI_HSE => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> I2S1SRCR {
        match value {
            0 => I2S1SRCR::PLLI2SR,
            1 => I2S1SRCR::I2S_CKIN,
            2 => I2S1SRCR::PLLR,
            3 => I2S1SRCR::HSI_HSE,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `PLLI2SR`"]
    #[inline]
    pub fn is_plli2sr(&self) -> bool {
        *self == I2S1SRCR::PLLI2SR
    }
    #[doc = "Checks if the value of the field is `I2S_CKIN`"]
    #[inline]
    pub fn is_i2s_ckin(&self) -> bool {
        *self == I2S1SRCR::I2S_CKIN
    }
    #[doc = "Checks if the value of the field is `PLLR`"]
    #[inline]
    pub fn is_pllr(&self) -> bool {
        *self == I2S1SRCR::PLLR
    }
    #[doc = "Checks if the value of the field is `HSI_HSE`"]
    #[inline]
    pub fn is_hsi_hse(&self) -> bool {
        *self == I2S1SRCR::HSI_HSE
    }
}
#[doc = "Possible values of the field `I2S2SRC`"]
pub type I2S2SRCR = I2S1SRCR;
#[doc = "Possible values of the field `CKDFSDM1SEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CKDFSDM1SELR {
    #[doc = "APB2 clock used as Kernel clock"]
    APB2,
    #[doc = "System clock used as Kernel clock"]
    SYSCLK,
}
impl CKDFSDM1SELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CKDFSDM1SELR::APB2 => false,
            CKDFSDM1SELR::SYSCLK => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CKDFSDM1SELR {
        match value {
            false => CKDFSDM1SELR::APB2,
            true => CKDFSDM1SELR::SYSCLK,
        }
    }
    #[doc = "Checks if the value of the field is `APB2`"]
    #[inline]
    pub fn is_apb2(&self) -> bool {
        *self == CKDFSDM1SELR::APB2
    }
    #[doc = "Checks if the value of the field is `SYSCLK`"]
    #[inline]
    pub fn is_sysclk(&self) -> bool {
        *self == CKDFSDM1SELR::SYSCLK
    }
}
#[doc = "Values that can be written to the field `CKDFSDM1ASEL`"]
pub enum CKDFSDM1ASELW {
    #[doc = "CK_I2S_APB1 selected as audio clock"]
    I2S1,
    #[doc = "CK_I2S_APB2 selected as audio clock"]
    I2S2,
}
impl CKDFSDM1ASELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            CKDFSDM1ASELW::I2S1 => 0,
            CKDFSDM1ASELW::I2S2 => 1,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CKDFSDM1ASELW<'a> {
    w: &'a mut W,
}
impl<'a> _CKDFSDM1ASELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CKDFSDM1ASELW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "CK_I2S_APB1 selected as audio clock"]
    #[inline]
    pub fn i2s1(self) -> &'a mut W {
        self.variant(CKDFSDM1ASELW::I2S1)
    }
    #[doc = "CK_I2S_APB2 selected as audio clock"]
    #[inline]
    pub fn i2s2(self) -> &'a mut W {
        self.variant(CKDFSDM1ASELW::I2S2)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 31;
        const OFFSET: u8 = 15;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `TIMPRE`"]
pub enum TIMPREW {
    #[doc = "If the APB prescaler is configured 1, TIMxCLK = PCLKx. Otherwise, TIMxCLK = 2xPCLKx"]
    MUL2,
    #[doc = "If the APB prescaler is configured 1, 2 or 4, TIMxCLK = HCLK. Otherwise, TIMxCLK = 4xPCLKx"]
    MUL4,
}
impl TIMPREW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            TIMPREW::MUL2 => false,
            TIMPREW::MUL4 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _TIMPREW<'a> {
    w: &'a mut W,
}
impl<'a> _TIMPREW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: TIMPREW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "If the APB prescaler is configured 1, TIMxCLK = PCLKx. Otherwise, TIMxCLK = 2xPCLKx"]
    #[inline]
    pub fn mul2(self) -> &'a mut W {
        self.variant(TIMPREW::MUL2)
    }
    #[doc = "If the APB prescaler is configured 1, 2 or 4, TIMxCLK = HCLK. Otherwise, TIMxCLK = 4xPCLKx"]
    #[inline]
    pub fn mul4(self) -> &'a mut W {
        self.variant(TIMPREW::MUL4)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 24;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `I2S1SRC`"]
pub enum I2S1SRCW {
    #[doc = "I2Sx clock frequency = f(PLLI2S_R)"]
    PLLI2SR,
    #[doc = "I2Sx clock frequency = I2S_CKIN Alternate function input frequency"]
    I2S_CKIN,
    #[doc = "I2Sx clock frequency = f(PLL_R)"]
    PLLR,
    #[doc = "I2Sx clock frequency = HSI/HSE depends on PLLSRC bit (PLLCFGR\\[22\\])"]
    HSI_HSE,
}
impl I2S1SRCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            I2S1SRCW::PLLI2SR => 0,
            I2S1SRCW::I2S_CKIN => 1,
            I2S1SRCW::PLLR => 2,
            I2S1SRCW::HSI_HSE => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _I2S1SRCW<'a> {
    w: &'a mut W,
}
impl<'a> _I2S1SRCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: I2S1SRCW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "I2Sx clock frequency = f(PLLI2S_R)"]
    #[inline]
    pub fn plli2sr(self) -> &'a mut W {
        self.variant(I2S1SRCW::PLLI2SR)
    }
    #[doc = "I2Sx clock frequency = I2S_CKIN Alternate function input frequency"]
    #[inline]
    pub fn i2s_ckin(self) -> &'a mut W {
        self.variant(I2S1SRCW::I2S_CKIN)
    }
    #[doc = "I2Sx clock frequency = f(PLL_R)"]
    #[inline]
    pub fn pllr(self) -> &'a mut W {
        self.variant(I2S1SRCW::PLLR)
    }
    #[doc = "I2Sx clock frequency = HSI/HSE depends on PLLSRC bit (PLLCFGR\\[22\\])"]
    #[inline]
    pub fn hsi_hse(self) -> &'a mut W {
        self.variant(I2S1SRCW::HSI_HSE)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 25;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `I2S2SRC`"]
pub type I2S2SRCW = I2S1SRCW;
#[doc = r" Proxy"]
pub struct _I2S2SRCW<'a> {
    w: &'a mut W,
}
impl<'a> _I2S2SRCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: I2S2SRCW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "I2Sx clock frequency = f(PLLI2S_R)"]
    #[inline]
    pub fn plli2sr(self) -> &'a mut W {
        self.variant(I2S1SRCW::PLLI2SR)
    }
    #[doc = "I2Sx clock frequency = I2S_CKIN Alternate function input frequency"]
    #[inline]
    pub fn i2s_ckin(self) -> &'a mut W {
        self.variant(I2S1SRCW::I2S_CKIN)
    }
    #[doc = "I2Sx clock frequency = f(PLL_R)"]
    #[inline]
    pub fn pllr(self) -> &'a mut W {
        self.variant(I2S1SRCW::PLLR)
    }
    #[doc = "I2Sx clock frequency = HSI/HSE depends on PLLSRC bit (PLLCFGR\\[22\\])"]
    #[inline]
    pub fn hsi_hse(self) -> &'a mut W {
        self.variant(I2S1SRCW::HSI_HSE)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 27;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CKDFSDM1SEL`"]
pub enum CKDFSDM1SELW {
    #[doc = "APB2 clock used as Kernel clock"]
    APB2,
    #[doc = "System clock used as Kernel clock"]
    SYSCLK,
}
impl CKDFSDM1SELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CKDFSDM1SELW::APB2 => false,
            CKDFSDM1SELW::SYSCLK => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CKDFSDM1SELW<'a> {
    w: &'a mut W,
}
impl<'a> _CKDFSDM1SELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CKDFSDM1SELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "APB2 clock used as Kernel clock"]
    #[inline]
    pub fn apb2(self) -> &'a mut W {
        self.variant(CKDFSDM1SELW::APB2)
    }
    #[doc = "System clock used as Kernel clock"]
    #[inline]
    pub fn sysclk(self) -> &'a mut W {
        self.variant(CKDFSDM1SELW::SYSCLK)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 31;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 15:19 - DFSDM1 audio clock selection"]
    #[inline]
    pub fn ckdfsdm1asel(&self) -> CKDFSDM1ASELR {
        CKDFSDM1ASELR::_from({
            const MASK: u8 = 31;
            const OFFSET: u8 = 15;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 24 - Timers clocks prescalers selection"]
    #[inline]
    pub fn timpre(&self) -> TIMPRER {
        TIMPRER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 24;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bits 25:26 - I2S APB1 clocks source selection (I2S2/3)"]
    #[inline]
    pub fn i2s1src(&self) -> I2S1SRCR {
        I2S1SRCR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 25;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 27:28 - I2S APB2 clocks source selection (I2S1/4/5)"]
    #[inline]
    pub fn i2s2src(&self) -> I2S2SRCR {
        I2S2SRCR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 27;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 31 - DFSDM1 Kernel clock selection"]
    #[inline]
    pub fn ckdfsdm1sel(&self) -> CKDFSDM1SELR {
        CKDFSDM1SELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 31;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 15:19 - DFSDM1 audio clock selection"]
    #[inline]
    pub fn ckdfsdm1asel(&mut self) -> _CKDFSDM1ASELW {
        _CKDFSDM1ASELW { w: self }
    }
    #[doc = "Bit 24 - Timers clocks prescalers selection"]
    #[inline]
    pub fn timpre(&mut self) -> _TIMPREW {
        _TIMPREW { w: self }
    }
    #[doc = "Bits 25:26 - I2S APB1 clocks source selection (I2S2/3)"]
    #[inline]
    pub fn i2s1src(&mut self) -> _I2S1SRCW {
        _I2S1SRCW { w: self }
    }
    #[doc = "Bits 27:28 - I2S APB2 clocks source selection (I2S1/4/5)"]
    #[inline]
    pub fn i2s2src(&mut self) -> _I2S2SRCW {
        _I2S2SRCW { w: self }
    }
    #[doc = "Bit 31 - DFSDM1 Kernel clock selection"]
    #[inline]
    pub fn ckdfsdm1sel(&mut self) -> _CKDFSDM1SELW {
        _CKDFSDM1SELW { w: self }
    }
}
