#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::DCKCFGR {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `CKDFSDM1ASEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CKDFSDM1ASELR {
    #[doc = "CK_I2S_APB1 selected as audio clock"]
    I2S1,
    #[doc = "CK_I2S_APB2 selected as audio clock"]
    I2S2,
}
impl CKDFSDM1ASELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CKDFSDM1ASELR::I2S1 => false,
            CKDFSDM1ASELR::I2S2 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CKDFSDM1ASELR {
        match value {
            false => CKDFSDM1ASELR::I2S1,
            true => CKDFSDM1ASELR::I2S2,
        }
    }
    #[doc = "Checks if the value of the field is `I2S1`"]
    #[inline]
    pub fn is_i2s1(&self) -> bool {
        *self == CKDFSDM1ASELR::I2S1
    }
    #[doc = "Checks if the value of the field is `I2S2`"]
    #[inline]
    pub fn is_i2s2(&self) -> bool {
        *self == CKDFSDM1ASELR::I2S2
    }
}
#[doc = "Possible values of the field `TIMPRE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TIMPRER {
    #[doc = "If the APB prescaler is configured 1, TIMxCLK = PCLKx. Otherwise, TIMxCLK = 2xPCLKx"]
    MUL2,
    #[doc = "If the APB prescaler is configured 1, 2 or 4, TIMxCLK = HCLK. Otherwise, TIMxCLK = 4xPCLKx"]
    MUL4,
}
impl TIMPRER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            TIMPRER::MUL2 => false,
            TIMPRER::MUL4 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> TIMPRER {
        match value {
            false => TIMPRER::MUL2,
            true => TIMPRER::MUL4,
        }
    }
    #[doc = "Checks if the value of the field is `MUL2`"]
    #[inline]
    pub fn is_mul2(&self) -> bool {
        *self == TIMPRER::MUL2
    }
    #[doc = "Checks if the value of the field is `MUL4`"]
    #[inline]
    pub fn is_mul4(&self) -> bool {
        *self == TIMPRER::MUL4
    }
}
#[doc = "Possible values of the field `I2S1SRC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum I2S1SRCR {
    #[doc = "I2Sx clock frequency = f(PLLI2S_R)"]
    PLLI2SR,
    #[doc = "I2Sx clock frequency = I2S_CKIN Alternate function input frequency"]
    I2S_CKIN,
    #[doc = "I2Sx clock frequency = f(PLL_R)"]
    PLLR,
    #[doc = "I2Sx clock frequency = HSI/HSE depends on PLLSRC bit (PLLCFGR\\[22\\])"]
    HSI_HSE,
}
impl I2S1SRCR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            I2S1SRCR::PLLI2SR => 0,
            I2S1SRCR::I2S_CKIN => 1,
            I2S1SRCR::PLLR => 2,
            I2S1SRCR::HSI_HSE => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> I2S1SRCR {
        match value {
            0 => I2S1SRCR::PLLI2SR,
            1 => I2S1SRCR::I2S_CKIN,
            2 => I2S1SRCR::PLLR,
            3 => I2S1SRCR::HSI_HSE,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `PLLI2SR`"]
    #[inline]
    pub fn is_plli2sr(&self) -> bool {
        *self == I2S1SRCR::PLLI2SR
    }
    #[doc = "Checks if the value of the field is `I2S_CKIN`"]
    #[inline]
    pub fn is_i2s_ckin(&self) -> bool {
        *self == I2S1SRCR::I2S_CKIN
    }
    #[doc = "Checks if the value of the field is `PLLR`"]
    #[inline]
    pub fn is_pllr(&self) -> bool {
        *self == I2S1SRCR::PLLR
    }
    #[doc = "Checks if the value of the field is `HSI_HSE`"]
    #[inline]
    pub fn is_hsi_hse(&self) -> bool {
        *self == I2S1SRCR::HSI_HSE
    }
}
#[doc = "Possible values of the field `I2S2SRC`"]
pub type I2S2SRCR = I2S1SRCR;
#[doc = "Possible values of the field `PLLI2SDIVR`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLLI2SDIVRR {
    #[doc = "PLLI2SDIVQ = /1"]
    DIV1,
    #[doc = "PLLI2SDIVQ = /2"]
    DIV2,
    #[doc = "PLLI2SDIVQ = /3"]
    DIV3,
    #[doc = "PLLI2SDIVQ = /4"]
    DIV4,
    #[doc = "PLLI2SDIVQ = /5"]
    DIV5,
    #[doc = "PLLI2SDIVQ = /6"]
    DIV6,
    #[doc = "PLLI2SDIVQ = /7"]
    DIV7,
    #[doc = "PLLI2SDIVQ = /8"]
    DIV8,
    #[doc = "PLLI2SDIVQ = /9"]
    DIV9,
    #[doc = "PLLI2SDIVQ = /10"]
    DIV10,
    #[doc = "PLLI2SDIVQ = /11"]
    DIV11,
    #[doc = "PLLI2SDIVQ = /12"]
    DIV12,
    #[doc = "PLLI2SDIVQ = /13"]
    DIV13,
    #[doc = "PLLI2SDIVQ = /14"]
    DIV14,
    #[doc = "PLLI2SDIVQ = /15"]
    DIV15,
    #[doc = "PLLI2SDIVQ = /16"]
    DIV16,
    #[doc = "PLLI2SDIVQ = /17"]
    DIV17,
    #[doc = "PLLI2SDIVQ = /18"]
    DIV18,
    #[doc = "PLLI2SDIVQ = /19"]
    DIV19,
    #[doc = "PLLI2SDIVQ = /20"]
    DIV20,
    #[doc = "PLLI2SDIVQ = /21"]
    DIV21,
    #[doc = "PLLI2SDIVQ = /22"]
    DIV22,
    #[doc = "PLLI2SDIVQ = /23"]
    DIV23,
    #[doc = "PLLI2SDIVQ = /24"]
    DIV24,
    #[doc = "PLLI2SDIVQ = /25"]
    DIV25,
    #[doc = "PLLI2SDIVQ = /26"]
    DIV26,
    #[doc = "PLLI2SDIVQ = /27"]
    DIV27,
    #[doc = "PLLI2SDIVQ = /28"]
    DIV28,
    #[doc = "PLLI2SDIVQ = /29"]
    DIV29,
    #[doc = "PLLI2SDIVQ = /30"]
    DIV30,
    #[doc = "PLLI2SDIVQ = /31"]
    DIV31,
    #[doc = "PLLI2SDIVQ = /32"]
    DIV32,
}
impl PLLI2SDIVRR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            PLLI2SDIVRR::DIV1 => 0,
            PLLI2SDIVRR::DIV2 => 1,
            PLLI2SDIVRR::DIV3 => 2,
            PLLI2SDIVRR::DIV4 => 3,
            PLLI2SDIVRR::DIV5 => 4,
            PLLI2SDIVRR::DIV6 => 5,
            PLLI2SDIVRR::DIV7 => 6,
            PLLI2SDIVRR::DIV8 => 7,
            PLLI2SDIVRR::DIV9 => 8,
            PLLI2SDIVRR::DIV10 => 9,
            PLLI2SDIVRR::DIV11 => 10,
            PLLI2SDIVRR::DIV12 => 11,
            PLLI2SDIVRR::DIV13 => 12,
            PLLI2SDIVRR::DIV14 => 13,
            PLLI2SDIVRR::DIV15 => 14,
            PLLI2SDIVRR::DIV16 => 15,
            PLLI2SDIVRR::DIV17 => 16,
            PLLI2SDIVRR::DIV18 => 17,
            PLLI2SDIVRR::DIV19 => 18,
            PLLI2SDIVRR::DIV20 => 19,
            PLLI2SDIVRR::DIV21 => 20,
            PLLI2SDIVRR::DIV22 => 21,
            PLLI2SDIVRR::DIV23 => 22,
            PLLI2SDIVRR::DIV24 => 23,
            PLLI2SDIVRR::DIV25 => 24,
            PLLI2SDIVRR::DIV26 => 25,
            PLLI2SDIVRR::DIV27 => 26,
            PLLI2SDIVRR::DIV28 => 27,
            PLLI2SDIVRR::DIV29 => 28,
            PLLI2SDIVRR::DIV30 => 29,
            PLLI2SDIVRR::DIV31 => 30,
            PLLI2SDIVRR::DIV32 => 31,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> PLLI2SDIVRR {
        match value {
            0 => PLLI2SDIVRR::DIV1,
            1 => PLLI2SDIVRR::DIV2,
            2 => PLLI2SDIVRR::DIV3,
            3 => PLLI2SDIVRR::DIV4,
            4 => PLLI2SDIVRR::DIV5,
            5 => PLLI2SDIVRR::DIV6,
            6 => PLLI2SDIVRR::DIV7,
            7 => PLLI2SDIVRR::DIV8,
            8 => PLLI2SDIVRR::DIV9,
            9 => PLLI2SDIVRR::DIV10,
            10 => PLLI2SDIVRR::DIV11,
            11 => PLLI2SDIVRR::DIV12,
            12 => PLLI2SDIVRR::DIV13,
            13 => PLLI2SDIVRR::DIV14,
            14 => PLLI2SDIVRR::DIV15,
            15 => PLLI2SDIVRR::DIV16,
            16 => PLLI2SDIVRR::DIV17,
            17 => PLLI2SDIVRR::DIV18,
            18 => PLLI2SDIVRR::DIV19,
            19 => PLLI2SDIVRR::DIV20,
            20 => PLLI2SDIVRR::DIV21,
            21 => PLLI2SDIVRR::DIV22,
            22 => PLLI2SDIVRR::DIV23,
            23 => PLLI2SDIVRR::DIV24,
            24 => PLLI2SDIVRR::DIV25,
            25 => PLLI2SDIVRR::DIV26,
            26 => PLLI2SDIVRR::DIV27,
            27 => PLLI2SDIVRR::DIV28,
            28 => PLLI2SDIVRR::DIV29,
            29 => PLLI2SDIVRR::DIV30,
            30 => PLLI2SDIVRR::DIV31,
            31 => PLLI2SDIVRR::DIV32,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DIV1`"]
    #[inline]
    pub fn is_div1(&self) -> bool {
        *self == PLLI2SDIVRR::DIV1
    }
    #[doc = "Checks if the value of the field is `DIV2`"]
    #[inline]
    pub fn is_div2(&self) -> bool {
        *self == PLLI2SDIVRR::DIV2
    }
    #[doc = "Checks if the value of the field is `DIV3`"]
    #[inline]
    pub fn is_div3(&self) -> bool {
        *self == PLLI2SDIVRR::DIV3
    }
    #[doc = "Checks if the value of the field is `DIV4`"]
    #[inline]
    pub fn is_div4(&self) -> bool {
        *self == PLLI2SDIVRR::DIV4
    }
    #[doc = "Checks if the value of the field is `DIV5`"]
    #[inline]
    pub fn is_div5(&self) -> bool {
        *self == PLLI2SDIVRR::DIV5
    }
    #[doc = "Checks if the value of the field is `DIV6`"]
    #[inline]
    pub fn is_div6(&self) -> bool {
        *self == PLLI2SDIVRR::DIV6
    }
    #[doc = "Checks if the value of the field is `DIV7`"]
    #[inline]
    pub fn is_div7(&self) -> bool {
        *self == PLLI2SDIVRR::DIV7
    }
    #[doc = "Checks if the value of the field is `DIV8`"]
    #[inline]
    pub fn is_div8(&self) -> bool {
        *self == PLLI2SDIVRR::DIV8
    }
    #[doc = "Checks if the value of the field is `DIV9`"]
    #[inline]
    pub fn is_div9(&self) -> bool {
        *self == PLLI2SDIVRR::DIV9
    }
    #[doc = "Checks if the value of the field is `DIV10`"]
    #[inline]
    pub fn is_div10(&self) -> bool {
        *self == PLLI2SDIVRR::DIV10
    }
    #[doc = "Checks if the value of the field is `DIV11`"]
    #[inline]
    pub fn is_div11(&self) -> bool {
        *self == PLLI2SDIVRR::DIV11
    }
    #[doc = "Checks if the value of the field is `DIV12`"]
    #[inline]
    pub fn is_div12(&self) -> bool {
        *self == PLLI2SDIVRR::DIV12
    }
    #[doc = "Checks if the value of the field is `DIV13`"]
    #[inline]
    pub fn is_div13(&self) -> bool {
        *self == PLLI2SDIVRR::DIV13
    }
    #[doc = "Checks if the value of the field is `DIV14`"]
    #[inline]
    pub fn is_div14(&self) -> bool {
        *self == PLLI2SDIVRR::DIV14
    }
    #[doc = "Checks if the value of the field is `DIV15`"]
    #[inline]
    pub fn is_div15(&self) -> bool {
        *self == PLLI2SDIVRR::DIV15
    }
    #[doc = "Checks if the value of the field is `DIV16`"]
    #[inline]
    pub fn is_div16(&self) -> bool {
        *self == PLLI2SDIVRR::DIV16
    }
    #[doc = "Checks if the value of the field is `DIV17`"]
    #[inline]
    pub fn is_div17(&self) -> bool {
        *self == PLLI2SDIVRR::DIV17
    }
    #[doc = "Checks if the value of the field is `DIV18`"]
    #[inline]
    pub fn is_div18(&self) -> bool {
        *self == PLLI2SDIVRR::DIV18
    }
    #[doc = "Checks if the value of the field is `DIV19`"]
    #[inline]
    pub fn is_div19(&self) -> bool {
        *self == PLLI2SDIVRR::DIV19
    }
    #[doc = "Checks if the value of the field is `DIV20`"]
    #[inline]
    pub fn is_div20(&self) -> bool {
        *self == PLLI2SDIVRR::DIV20
    }
    #[doc = "Checks if the value of the field is `DIV21`"]
    #[inline]
    pub fn is_div21(&self) -> bool {
        *self == PLLI2SDIVRR::DIV21
    }
    #[doc = "Checks if the value of the field is `DIV22`"]
    #[inline]
    pub fn is_div22(&self) -> bool {
        *self == PLLI2SDIVRR::DIV22
    }
    #[doc = "Checks if the value of the field is `DIV23`"]
    #[inline]
    pub fn is_div23(&self) -> bool {
        *self == PLLI2SDIVRR::DIV23
    }
    #[doc = "Checks if the value of the field is `DIV24`"]
    #[inline]
    pub fn is_div24(&self) -> bool {
        *self == PLLI2SDIVRR::DIV24
    }
    #[doc = "Checks if the value of the field is `DIV25`"]
    #[inline]
    pub fn is_div25(&self) -> bool {
        *self == PLLI2SDIVRR::DIV25
    }
    #[doc = "Checks if the value of the field is `DIV26`"]
    #[inline]
    pub fn is_div26(&self) -> bool {
        *self == PLLI2SDIVRR::DIV26
    }
    #[doc = "Checks if the value of the field is `DIV27`"]
    #[inline]
    pub fn is_div27(&self) -> bool {
        *self == PLLI2SDIVRR::DIV27
    }
    #[doc = "Checks if the value of the field is `DIV28`"]
    #[inline]
    pub fn is_div28(&self) -> bool {
        *self == PLLI2SDIVRR::DIV28
    }
    #[doc = "Checks if the value of the field is `DIV29`"]
    #[inline]
    pub fn is_div29(&self) -> bool {
        *self == PLLI2SDIVRR::DIV29
    }
    #[doc = "Checks if the value of the field is `DIV30`"]
    #[inline]
    pub fn is_div30(&self) -> bool {
        *self == PLLI2SDIVRR::DIV30
    }
    #[doc = "Checks if the value of the field is `DIV31`"]
    #[inline]
    pub fn is_div31(&self) -> bool {
        *self == PLLI2SDIVRR::DIV31
    }
    #[doc = "Checks if the value of the field is `DIV32`"]
    #[inline]
    pub fn is_div32(&self) -> bool {
        *self == PLLI2SDIVRR::DIV32
    }
}
#[doc = "Possible values of the field `PLLDIVR`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLLDIVRR {
    #[doc = "PLLSAIDIVQ = /1"]
    DIV1,
    #[doc = "PLLSAIDIVQ = /2"]
    DIV2,
    #[doc = "PLLSAIDIVQ = /3"]
    DIV3,
    #[doc = "PLLSAIDIVQ = /4"]
    DIV4,
    #[doc = "PLLSAIDIVQ = /5"]
    DIV5,
    #[doc = "PLLSAIDIVQ = /6"]
    DIV6,
    #[doc = "PLLSAIDIVQ = /7"]
    DIV7,
    #[doc = "PLLSAIDIVQ = /8"]
    DIV8,
    #[doc = "PLLSAIDIVQ = /9"]
    DIV9,
    #[doc = "PLLSAIDIVQ = /10"]
    DIV10,
    #[doc = "PLLSAIDIVQ = /11"]
    DIV11,
    #[doc = "PLLSAIDIVQ = /12"]
    DIV12,
    #[doc = "PLLSAIDIVQ = /13"]
    DIV13,
    #[doc = "PLLSAIDIVQ = /14"]
    DIV14,
    #[doc = "PLLSAIDIVQ = /15"]
    DIV15,
    #[doc = "PLLSAIDIVQ = /16"]
    DIV16,
    #[doc = "PLLSAIDIVQ = /17"]
    DIV17,
    #[doc = "PLLSAIDIVQ = /18"]
    DIV18,
    #[doc = "PLLSAIDIVQ = /19"]
    DIV19,
    #[doc = "PLLSAIDIVQ = /20"]
    DIV20,
    #[doc = "PLLSAIDIVQ = /21"]
    DIV21,
    #[doc = "PLLSAIDIVQ = /22"]
    DIV22,
    #[doc = "PLLSAIDIVQ = /23"]
    DIV23,
    #[doc = "PLLSAIDIVQ = /24"]
    DIV24,
    #[doc = "PLLSAIDIVQ = /25"]
    DIV25,
    #[doc = "PLLSAIDIVQ = /26"]
    DIV26,
    #[doc = "PLLSAIDIVQ = /27"]
    DIV27,
    #[doc = "PLLSAIDIVQ = /28"]
    DIV28,
    #[doc = "PLLSAIDIVQ = /29"]
    DIV29,
    #[doc = "PLLSAIDIVQ = /30"]
    DIV30,
    #[doc = "PLLSAIDIVQ = /31"]
    DIV31,
    #[doc = "PLLSAIDIVQ = /32"]
    DIV32,
}
impl PLLDIVRR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            PLLDIVRR::DIV1 => 0,
            PLLDIVRR::DIV2 => 1,
            PLLDIVRR::DIV3 => 2,
            PLLDIVRR::DIV4 => 3,
            PLLDIVRR::DIV5 => 4,
            PLLDIVRR::DIV6 => 5,
            PLLDIVRR::DIV7 => 6,
            PLLDIVRR::DIV8 => 7,
            PLLDIVRR::DIV9 => 8,
            PLLDIVRR::DIV10 => 9,
            PLLDIVRR::DIV11 => 10,
            PLLDIVRR::DIV12 => 11,
            PLLDIVRR::DIV13 => 12,
            PLLDIVRR::DIV14 => 13,
            PLLDIVRR::DIV15 => 14,
            PLLDIVRR::DIV16 => 15,
            PLLDIVRR::DIV17 => 16,
            PLLDIVRR::DIV18 => 17,
            PLLDIVRR::DIV19 => 18,
            PLLDIVRR::DIV20 => 19,
            PLLDIVRR::DIV21 => 20,
            PLLDIVRR::DIV22 => 21,
            PLLDIVRR::DIV23 => 22,
            PLLDIVRR::DIV24 => 23,
            PLLDIVRR::DIV25 => 24,
            PLLDIVRR::DIV26 => 25,
            PLLDIVRR::DIV27 => 26,
            PLLDIVRR::DIV28 => 27,
            PLLDIVRR::DIV29 => 28,
            PLLDIVRR::DIV30 => 29,
            PLLDIVRR::DIV31 => 30,
            PLLDIVRR::DIV32 => 31,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> PLLDIVRR {
        match value {
            0 => PLLDIVRR::DIV1,
            1 => PLLDIVRR::DIV2,
            2 => PLLDIVRR::DIV3,
            3 => PLLDIVRR::DIV4,
            4 => PLLDIVRR::DIV5,
            5 => PLLDIVRR::DIV6,
            6 => PLLDIVRR::DIV7,
            7 => PLLDIVRR::DIV8,
            8 => PLLDIVRR::DIV9,
            9 => PLLDIVRR::DIV10,
            10 => PLLDIVRR::DIV11,
            11 => PLLDIVRR::DIV12,
            12 => PLLDIVRR::DIV13,
            13 => PLLDIVRR::DIV14,
            14 => PLLDIVRR::DIV15,
            15 => PLLDIVRR::DIV16,
            16 => PLLDIVRR::DIV17,
            17 => PLLDIVRR::DIV18,
            18 => PLLDIVRR::DIV19,
            19 => PLLDIVRR::DIV20,
            20 => PLLDIVRR::DIV21,
            21 => PLLDIVRR::DIV22,
            22 => PLLDIVRR::DIV23,
            23 => PLLDIVRR::DIV24,
            24 => PLLDIVRR::DIV25,
            25 => PLLDIVRR::DIV26,
            26 => PLLDIVRR::DIV27,
            27 => PLLDIVRR::DIV28,
            28 => PLLDIVRR::DIV29,
            29 => PLLDIVRR::DIV30,
            30 => PLLDIVRR::DIV31,
            31 => PLLDIVRR::DIV32,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DIV1`"]
    #[inline]
    pub fn is_div1(&self) -> bool {
        *self == PLLDIVRR::DIV1
    }
    #[doc = "Checks if the value of the field is `DIV2`"]
    #[inline]
    pub fn is_div2(&self) -> bool {
        *self == PLLDIVRR::DIV2
    }
    #[doc = "Checks if the value of the field is `DIV3`"]
    #[inline]
    pub fn is_div3(&self) -> bool {
        *self == PLLDIVRR::DIV3
    }
    #[doc = "Checks if the value of the field is `DIV4`"]
    #[inline]
    pub fn is_div4(&self) -> bool {
        *self == PLLDIVRR::DIV4
    }
    #[doc = "Checks if the value of the field is `DIV5`"]
    #[inline]
    pub fn is_div5(&self) -> bool {
        *self == PLLDIVRR::DIV5
    }
    #[doc = "Checks if the value of the field is `DIV6`"]
    #[inline]
    pub fn is_div6(&self) -> bool {
        *self == PLLDIVRR::DIV6
    }
    #[doc = "Checks if the value of the field is `DIV7`"]
    #[inline]
    pub fn is_div7(&self) -> bool {
        *self == PLLDIVRR::DIV7
    }
    #[doc = "Checks if the value of the field is `DIV8`"]
    #[inline]
    pub fn is_div8(&self) -> bool {
        *self == PLLDIVRR::DIV8
    }
    #[doc = "Checks if the value of the field is `DIV9`"]
    #[inline]
    pub fn is_div9(&self) -> bool {
        *self == PLLDIVRR::DIV9
    }
    #[doc = "Checks if the value of the field is `DIV10`"]
    #[inline]
    pub fn is_div10(&self) -> bool {
        *self == PLLDIVRR::DIV10
    }
    #[doc = "Checks if the value of the field is `DIV11`"]
    #[inline]
    pub fn is_div11(&self) -> bool {
        *self == PLLDIVRR::DIV11
    }
    #[doc = "Checks if the value of the field is `DIV12`"]
    #[inline]
    pub fn is_div12(&self) -> bool {
        *self == PLLDIVRR::DIV12
    }
    #[doc = "Checks if the value of the field is `DIV13`"]
    #[inline]
    pub fn is_div13(&self) -> bool {
        *self == PLLDIVRR::DIV13
    }
    #[doc = "Checks if the value of the field is `DIV14`"]
    #[inline]
    pub fn is_div14(&self) -> bool {
        *self == PLLDIVRR::DIV14
    }
    #[doc = "Checks if the value of the field is `DIV15`"]
    #[inline]
    pub fn is_div15(&self) -> bool {
        *self == PLLDIVRR::DIV15
    }
    #[doc = "Checks if the value of the field is `DIV16`"]
    #[inline]
    pub fn is_div16(&self) -> bool {
        *self == PLLDIVRR::DIV16
    }
    #[doc = "Checks if the value of the field is `DIV17`"]
    #[inline]
    pub fn is_div17(&self) -> bool {
        *self == PLLDIVRR::DIV17
    }
    #[doc = "Checks if the value of the field is `DIV18`"]
    #[inline]
    pub fn is_div18(&self) -> bool {
        *self == PLLDIVRR::DIV18
    }
    #[doc = "Checks if the value of the field is `DIV19`"]
    #[inline]
    pub fn is_div19(&self) -> bool {
        *self == PLLDIVRR::DIV19
    }
    #[doc = "Checks if the value of the field is `DIV20`"]
    #[inline]
    pub fn is_div20(&self) -> bool {
        *self == PLLDIVRR::DIV20
    }
    #[doc = "Checks if the value of the field is `DIV21`"]
    #[inline]
    pub fn is_div21(&self) -> bool {
        *self == PLLDIVRR::DIV21
    }
    #[doc = "Checks if the value of the field is `DIV22`"]
    #[inline]
    pub fn is_div22(&self) -> bool {
        *self == PLLDIVRR::DIV22
    }
    #[doc = "Checks if the value of the field is `DIV23`"]
    #[inline]
    pub fn is_div23(&self) -> bool {
        *self == PLLDIVRR::DIV23
    }
    #[doc = "Checks if the value of the field is `DIV24`"]
    #[inline]
    pub fn is_div24(&self) -> bool {
        *self == PLLDIVRR::DIV24
    }
    #[doc = "Checks if the value of the field is `DIV25`"]
    #[inline]
    pub fn is_div25(&self) -> bool {
        *self == PLLDIVRR::DIV25
    }
    #[doc = "Checks if the value of the field is `DIV26`"]
    #[inline]
    pub fn is_div26(&self) -> bool {
        *self == PLLDIVRR::DIV26
    }
    #[doc = "Checks if the value of the field is `DIV27`"]
    #[inline]
    pub fn is_div27(&self) -> bool {
        *self == PLLDIVRR::DIV27
    }
    #[doc = "Checks if the value of the field is `DIV28`"]
    #[inline]
    pub fn is_div28(&self) -> bool {
        *self == PLLDIVRR::DIV28
    }
    #[doc = "Checks if the value of the field is `DIV29`"]
    #[inline]
    pub fn is_div29(&self) -> bool {
        *self == PLLDIVRR::DIV29
    }
    #[doc = "Checks if the value of the field is `DIV30`"]
    #[inline]
    pub fn is_div30(&self) -> bool {
        *self == PLLDIVRR::DIV30
    }
    #[doc = "Checks if the value of the field is `DIV31`"]
    #[inline]
    pub fn is_div31(&self) -> bool {
        *self == PLLDIVRR::DIV31
    }
    #[doc = "Checks if the value of the field is `DIV32`"]
    #[inline]
    pub fn is_div32(&self) -> bool {
        *self == PLLDIVRR::DIV32
    }
}
#[doc = "Possible values of the field `CKDFSDM2ASEL`"]
pub type CKDFSDM2ASELR = CKDFSDM1ASELR;
#[doc = "Possible values of the field `SAI1ASRC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SAI1ASRCR {
    #[doc = "SAI1-A clock frequency = f(PLLSAI_Q) / PLLSAIDIVQ"]
    PLLSAI,
    #[doc = "SAI1-A clock frequency = f(PLLI2S_Q) / PLLI2SDIVQ"]
    PLLI2S,
    #[doc = "SAI1-A clock frequency = Alternate function input frequency"]
    I2S_CKIN,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl SAI1ASRCR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            SAI1ASRCR::PLLSAI => 0,
            SAI1ASRCR::PLLI2S => 1,
            SAI1ASRCR::I2S_CKIN => 2,
            SAI1ASRCR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> SAI1ASRCR {
        match value {
            0 => SAI1ASRCR::PLLSAI,
            1 => SAI1ASRCR::PLLI2S,
            2 => SAI1ASRCR::I2S_CKIN,
            i => SAI1ASRCR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `PLLSAI`"]
    #[inline]
    pub fn is_pllsai(&self) -> bool {
        *self == SAI1ASRCR::PLLSAI
    }
    #[doc = "Checks if the value of the field is `PLLI2S`"]
    #[inline]
    pub fn is_plli2s(&self) -> bool {
        *self == SAI1ASRCR::PLLI2S
    }
    #[doc = "Checks if the value of the field is `I2S_CKIN`"]
    #[inline]
    pub fn is_i2s_ckin(&self) -> bool {
        *self == SAI1ASRCR::I2S_CKIN
    }
}
#[doc = "Possible values of the field `SAI1BSRC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SAI1BSRCR {
    #[doc = "SAI1-B clock frequency = f(PLLSAI_Q) / PLLSAIDIVQ"]
    PLLSAI,
    #[doc = "SAI1-B clock frequency = f(PLLI2S_Q) / PLLI2SDIVQ"]
    PLLI2S,
    #[doc = "SAI1-B clock frequency = Alternate function input frequency"]
    I2S_CKIN,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl SAI1BSRCR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            SAI1BSRCR::PLLSAI => 0,
            SAI1BSRCR::PLLI2S => 1,
            SAI1BSRCR::I2S_CKIN => 2,
            SAI1BSRCR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> SAI1BSRCR {
        match value {
            0 => SAI1BSRCR::PLLSAI,
            1 => SAI1BSRCR::PLLI2S,
            2 => SAI1BSRCR::I2S_CKIN,
            i => SAI1BSRCR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `PLLSAI`"]
    #[inline]
    pub fn is_pllsai(&self) -> bool {
        *self == SAI1BSRCR::PLLSAI
    }
    #[doc = "Checks if the value of the field is `PLLI2S`"]
    #[inline]
    pub fn is_plli2s(&self) -> bool {
        *self == SAI1BSRCR::PLLI2S
    }
    #[doc = "Checks if the value of the field is `I2S_CKIN`"]
    #[inline]
    pub fn is_i2s_ckin(&self) -> bool {
        *self == SAI1BSRCR::I2S_CKIN
    }
}
#[doc = "Possible values of the field `CKDFSDM1SEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CKDFSDM1SELR {
    #[doc = "APB2 clock used as Kernel clock"]
    APB2,
    #[doc = "System clock used as Kernel clock"]
    SYSCLK,
}
impl CKDFSDM1SELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CKDFSDM1SELR::APB2 => false,
            CKDFSDM1SELR::SYSCLK => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CKDFSDM1SELR {
        match value {
            false => CKDFSDM1SELR::APB2,
            true => CKDFSDM1SELR::SYSCLK,
        }
    }
    #[doc = "Checks if the value of the field is `APB2`"]
    #[inline]
    pub fn is_apb2(&self) -> bool {
        *self == CKDFSDM1SELR::APB2
    }
    #[doc = "Checks if the value of the field is `SYSCLK`"]
    #[inline]
    pub fn is_sysclk(&self) -> bool {
        *self == CKDFSDM1SELR::SYSCLK
    }
}
#[doc = "Values that can be written to the field `CKDFSDM1ASEL`"]
pub enum CKDFSDM1ASELW {
    #[doc = "CK_I2S_APB1 selected as audio clock"]
    I2S1,
    #[doc = "CK_I2S_APB2 selected as audio clock"]
    I2S2,
}
impl CKDFSDM1ASELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CKDFSDM1ASELW::I2S1 => false,
            CKDFSDM1ASELW::I2S2 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CKDFSDM1ASELW<'a> {
    w: &'a mut W,
}
impl<'a> _CKDFSDM1ASELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CKDFSDM1ASELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "CK_I2S_APB1 selected as audio clock"]
    #[inline]
    pub fn i2s1(self) -> &'a mut W {
        self.variant(CKDFSDM1ASELW::I2S1)
    }
    #[doc = "CK_I2S_APB2 selected as audio clock"]
    #[inline]
    pub fn i2s2(self) -> &'a mut W {
        self.variant(CKDFSDM1ASELW::I2S2)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 15;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `TIMPRE`"]
pub enum TIMPREW {
    #[doc = "If the APB prescaler is configured 1, TIMxCLK = PCLKx. Otherwise, TIMxCLK = 2xPCLKx"]
    MUL2,
    #[doc = "If the APB prescaler is configured 1, 2 or 4, TIMxCLK = HCLK. Otherwise, TIMxCLK = 4xPCLKx"]
    MUL4,
}
impl TIMPREW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            TIMPREW::MUL2 => false,
            TIMPREW::MUL4 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _TIMPREW<'a> {
    w: &'a mut W,
}
impl<'a> _TIMPREW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: TIMPREW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "If the APB prescaler is configured 1, TIMxCLK = PCLKx. Otherwise, TIMxCLK = 2xPCLKx"]
    #[inline]
    pub fn mul2(self) -> &'a mut W {
        self.variant(TIMPREW::MUL2)
    }
    #[doc = "If the APB prescaler is configured 1, 2 or 4, TIMxCLK = HCLK. Otherwise, TIMxCLK = 4xPCLKx"]
    #[inline]
    pub fn mul4(self) -> &'a mut W {
        self.variant(TIMPREW::MUL4)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 24;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `I2S1SRC`"]
pub enum I2S1SRCW {
    #[doc = "I2Sx clock frequency = f(PLLI2S_R)"]
    PLLI2SR,
    #[doc = "I2Sx clock frequency = I2S_CKIN Alternate function input frequency"]
    I2S_CKIN,
    #[doc = "I2Sx clock frequency = f(PLL_R)"]
    PLLR,
    #[doc = "I2Sx clock frequency = HSI/HSE depends on PLLSRC bit (PLLCFGR\\[22\\])"]
    HSI_HSE,
}
impl I2S1SRCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            I2S1SRCW::PLLI2SR => 0,
            I2S1SRCW::I2S_CKIN => 1,
            I2S1SRCW::PLLR => 2,
            I2S1SRCW::HSI_HSE => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _I2S1SRCW<'a> {
    w: &'a mut W,
}
impl<'a> _I2S1SRCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: I2S1SRCW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "I2Sx clock frequency = f(PLLI2S_R)"]
    #[inline]
    pub fn plli2sr(self) -> &'a mut W {
        self.variant(I2S1SRCW::PLLI2SR)
    }
    #[doc = "I2Sx clock frequency = I2S_CKIN Alternate function input frequency"]
    #[inline]
    pub fn i2s_ckin(self) -> &'a mut W {
        self.variant(I2S1SRCW::I2S_CKIN)
    }
    #[doc = "I2Sx clock frequency = f(PLL_R)"]
    #[inline]
    pub fn pllr(self) -> &'a mut W {
        self.variant(I2S1SRCW::PLLR)
    }
    #[doc = "I2Sx clock frequency = HSI/HSE depends on PLLSRC bit (PLLCFGR\\[22\\])"]
    #[inline]
    pub fn hsi_hse(self) -> &'a mut W {
        self.variant(I2S1SRCW::HSI_HSE)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 25;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `I2S2SRC`"]
pub type I2S2SRCW = I2S1SRCW;
#[doc = r" Proxy"]
pub struct _I2S2SRCW<'a> {
    w: &'a mut W,
}
impl<'a> _I2S2SRCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: I2S2SRCW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "I2Sx clock frequency = f(PLLI2S_R)"]
    #[inline]
    pub fn plli2sr(self) -> &'a mut W {
        self.variant(I2S1SRCW::PLLI2SR)
    }
    #[doc = "I2Sx clock frequency = I2S_CKIN Alternate function input frequency"]
    #[inline]
    pub fn i2s_ckin(self) -> &'a mut W {
        self.variant(I2S1SRCW::I2S_CKIN)
    }
    #[doc = "I2Sx clock frequency = f(PLL_R)"]
    #[inline]
    pub fn pllr(self) -> &'a mut W {
        self.variant(I2S1SRCW::PLLR)
    }
    #[doc = "I2Sx clock frequency = HSI/HSE depends on PLLSRC bit (PLLCFGR\\[22\\])"]
    #[inline]
    pub fn hsi_hse(self) -> &'a mut W {
        self.variant(I2S1SRCW::HSI_HSE)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 27;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PLLI2SDIVR`"]
pub enum PLLI2SDIVRW {
    #[doc = "PLLI2SDIVQ = /1"]
    DIV1,
    #[doc = "PLLI2SDIVQ = /2"]
    DIV2,
    #[doc = "PLLI2SDIVQ = /3"]
    DIV3,
    #[doc = "PLLI2SDIVQ = /4"]
    DIV4,
    #[doc = "PLLI2SDIVQ = /5"]
    DIV5,
    #[doc = "PLLI2SDIVQ = /6"]
    DIV6,
    #[doc = "PLLI2SDIVQ = /7"]
    DIV7,
    #[doc = "PLLI2SDIVQ = /8"]
    DIV8,
    #[doc = "PLLI2SDIVQ = /9"]
    DIV9,
    #[doc = "PLLI2SDIVQ = /10"]
    DIV10,
    #[doc = "PLLI2SDIVQ = /11"]
    DIV11,
    #[doc = "PLLI2SDIVQ = /12"]
    DIV12,
    #[doc = "PLLI2SDIVQ = /13"]
    DIV13,
    #[doc = "PLLI2SDIVQ = /14"]
    DIV14,
    #[doc = "PLLI2SDIVQ = /15"]
    DIV15,
    #[doc = "PLLI2SDIVQ = /16"]
    DIV16,
    #[doc = "PLLI2SDIVQ = /17"]
    DIV17,
    #[doc = "PLLI2SDIVQ = /18"]
    DIV18,
    #[doc = "PLLI2SDIVQ = /19"]
    DIV19,
    #[doc = "PLLI2SDIVQ = /20"]
    DIV20,
    #[doc = "PLLI2SDIVQ = /21"]
    DIV21,
    #[doc = "PLLI2SDIVQ = /22"]
    DIV22,
    #[doc = "PLLI2SDIVQ = /23"]
    DIV23,
    #[doc = "PLLI2SDIVQ = /24"]
    DIV24,
    #[doc = "PLLI2SDIVQ = /25"]
    DIV25,
    #[doc = "PLLI2SDIVQ = /26"]
    DIV26,
    #[doc = "PLLI2SDIVQ = /27"]
    DIV27,
    #[doc = "PLLI2SDIVQ = /28"]
    DIV28,
    #[doc = "PLLI2SDIVQ = /29"]
    DIV29,
    #[doc = "PLLI2SDIVQ = /30"]
    DIV30,
    #[doc = "PLLI2SDIVQ = /31"]
    DIV31,
    #[doc = "PLLI2SDIVQ = /32"]
    DIV32,
}
impl PLLI2SDIVRW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            PLLI2SDIVRW::DIV1 => 0,
            PLLI2SDIVRW::DIV2 => 1,
            PLLI2SDIVRW::DIV3 => 2,
            PLLI2SDIVRW::DIV4 => 3,
            PLLI2SDIVRW::DIV5 => 4,
            PLLI2SDIVRW::DIV6 => 5,
            PLLI2SDIVRW::DIV7 => 6,
            PLLI2SDIVRW::DIV8 => 7,
            PLLI2SDIVRW::DIV9 => 8,
            PLLI2SDIVRW::DIV10 => 9,
            PLLI2SDIVRW::DIV11 => 10,
            PLLI2SDIVRW::DIV12 => 11,
            PLLI2SDIVRW::DIV13 => 12,
            PLLI2SDIVRW::DIV14 => 13,
            PLLI2SDIVRW::DIV15 => 14,
            PLLI2SDIVRW::DIV16 => 15,
            PLLI2SDIVRW::DIV17 => 16,
            PLLI2SDIVRW::DIV18 => 17,
            PLLI2SDIVRW::DIV19 => 18,
            PLLI2SDIVRW::DIV20 => 19,
            PLLI2SDIVRW::DIV21 => 20,
            PLLI2SDIVRW::DIV22 => 21,
            PLLI2SDIVRW::DIV23 => 22,
            PLLI2SDIVRW::DIV24 => 23,
            PLLI2SDIVRW::DIV25 => 24,
            PLLI2SDIVRW::DIV26 => 25,
            PLLI2SDIVRW::DIV27 => 26,
            PLLI2SDIVRW::DIV28 => 27,
            PLLI2SDIVRW::DIV29 => 28,
            PLLI2SDIVRW::DIV30 => 29,
            PLLI2SDIVRW::DIV31 => 30,
            PLLI2SDIVRW::DIV32 => 31,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PLLI2SDIVRW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLI2SDIVRW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PLLI2SDIVRW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "PLLI2SDIVQ = /1"]
    #[inline]
    pub fn div1(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV1)
    }
    #[doc = "PLLI2SDIVQ = /2"]
    #[inline]
    pub fn div2(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV2)
    }
    #[doc = "PLLI2SDIVQ = /3"]
    #[inline]
    pub fn div3(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV3)
    }
    #[doc = "PLLI2SDIVQ = /4"]
    #[inline]
    pub fn div4(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV4)
    }
    #[doc = "PLLI2SDIVQ = /5"]
    #[inline]
    pub fn div5(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV5)
    }
    #[doc = "PLLI2SDIVQ = /6"]
    #[inline]
    pub fn div6(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV6)
    }
    #[doc = "PLLI2SDIVQ = /7"]
    #[inline]
    pub fn div7(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV7)
    }
    #[doc = "PLLI2SDIVQ = /8"]
    #[inline]
    pub fn div8(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV8)
    }
    #[doc = "PLLI2SDIVQ = /9"]
    #[inline]
    pub fn div9(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV9)
    }
    #[doc = "PLLI2SDIVQ = /10"]
    #[inline]
    pub fn div10(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV10)
    }
    #[doc = "PLLI2SDIVQ = /11"]
    #[inline]
    pub fn div11(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV11)
    }
    #[doc = "PLLI2SDIVQ = /12"]
    #[inline]
    pub fn div12(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV12)
    }
    #[doc = "PLLI2SDIVQ = /13"]
    #[inline]
    pub fn div13(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV13)
    }
    #[doc = "PLLI2SDIVQ = /14"]
    #[inline]
    pub fn div14(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV14)
    }
    #[doc = "PLLI2SDIVQ = /15"]
    #[inline]
    pub fn div15(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV15)
    }
    #[doc = "PLLI2SDIVQ = /16"]
    #[inline]
    pub fn div16(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV16)
    }
    #[doc = "PLLI2SDIVQ = /17"]
    #[inline]
    pub fn div17(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV17)
    }
    #[doc = "PLLI2SDIVQ = /18"]
    #[inline]
    pub fn div18(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV18)
    }
    #[doc = "PLLI2SDIVQ = /19"]
    #[inline]
    pub fn div19(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV19)
    }
    #[doc = "PLLI2SDIVQ = /20"]
    #[inline]
    pub fn div20(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV20)
    }
    #[doc = "PLLI2SDIVQ = /21"]
    #[inline]
    pub fn div21(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV21)
    }
    #[doc = "PLLI2SDIVQ = /22"]
    #[inline]
    pub fn div22(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV22)
    }
    #[doc = "PLLI2SDIVQ = /23"]
    #[inline]
    pub fn div23(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV23)
    }
    #[doc = "PLLI2SDIVQ = /24"]
    #[inline]
    pub fn div24(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV24)
    }
    #[doc = "PLLI2SDIVQ = /25"]
    #[inline]
    pub fn div25(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV25)
    }
    #[doc = "PLLI2SDIVQ = /26"]
    #[inline]
    pub fn div26(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV26)
    }
    #[doc = "PLLI2SDIVQ = /27"]
    #[inline]
    pub fn div27(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV27)
    }
    #[doc = "PLLI2SDIVQ = /28"]
    #[inline]
    pub fn div28(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV28)
    }
    #[doc = "PLLI2SDIVQ = /29"]
    #[inline]
    pub fn div29(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV29)
    }
    #[doc = "PLLI2SDIVQ = /30"]
    #[inline]
    pub fn div30(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV30)
    }
    #[doc = "PLLI2SDIVQ = /31"]
    #[inline]
    pub fn div31(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV31)
    }
    #[doc = "PLLI2SDIVQ = /32"]
    #[inline]
    pub fn div32(self) -> &'a mut W {
        self.variant(PLLI2SDIVRW::DIV32)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 31;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PLLDIVR`"]
pub enum PLLDIVRW {
    #[doc = "PLLSAIDIVQ = /1"]
    DIV1,
    #[doc = "PLLSAIDIVQ = /2"]
    DIV2,
    #[doc = "PLLSAIDIVQ = /3"]
    DIV3,
    #[doc = "PLLSAIDIVQ = /4"]
    DIV4,
    #[doc = "PLLSAIDIVQ = /5"]
    DIV5,
    #[doc = "PLLSAIDIVQ = /6"]
    DIV6,
    #[doc = "PLLSAIDIVQ = /7"]
    DIV7,
    #[doc = "PLLSAIDIVQ = /8"]
    DIV8,
    #[doc = "PLLSAIDIVQ = /9"]
    DIV9,
    #[doc = "PLLSAIDIVQ = /10"]
    DIV10,
    #[doc = "PLLSAIDIVQ = /11"]
    DIV11,
    #[doc = "PLLSAIDIVQ = /12"]
    DIV12,
    #[doc = "PLLSAIDIVQ = /13"]
    DIV13,
    #[doc = "PLLSAIDIVQ = /14"]
    DIV14,
    #[doc = "PLLSAIDIVQ = /15"]
    DIV15,
    #[doc = "PLLSAIDIVQ = /16"]
    DIV16,
    #[doc = "PLLSAIDIVQ = /17"]
    DIV17,
    #[doc = "PLLSAIDIVQ = /18"]
    DIV18,
    #[doc = "PLLSAIDIVQ = /19"]
    DIV19,
    #[doc = "PLLSAIDIVQ = /20"]
    DIV20,
    #[doc = "PLLSAIDIVQ = /21"]
    DIV21,
    #[doc = "PLLSAIDIVQ = /22"]
    DIV22,
    #[doc = "PLLSAIDIVQ = /23"]
    DIV23,
    #[doc = "PLLSAIDIVQ = /24"]
    DIV24,
    #[doc = "PLLSAIDIVQ = /25"]
    DIV25,
    #[doc = "PLLSAIDIVQ = /26"]
    DIV26,
    #[doc = "PLLSAIDIVQ = /27"]
    DIV27,
    #[doc = "PLLSAIDIVQ = /28"]
    DIV28,
    #[doc = "PLLSAIDIVQ = /29"]
    DIV29,
    #[doc = "PLLSAIDIVQ = /30"]
    DIV30,
    #[doc = "PLLSAIDIVQ = /31"]
    DIV31,
    #[doc = "PLLSAIDIVQ = /32"]
    DIV32,
}
impl PLLDIVRW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            PLLDIVRW::DIV1 => 0,
            PLLDIVRW::DIV2 => 1,
            PLLDIVRW::DIV3 => 2,
            PLLDIVRW::DIV4 => 3,
            PLLDIVRW::DIV5 => 4,
            PLLDIVRW::DIV6 => 5,
            PLLDIVRW::DIV7 => 6,
            PLLDIVRW::DIV8 => 7,
            PLLDIVRW::DIV9 => 8,
            PLLDIVRW::DIV10 => 9,
            PLLDIVRW::DIV11 => 10,
            PLLDIVRW::DIV12 => 11,
            PLLDIVRW::DIV13 => 12,
            PLLDIVRW::DIV14 => 13,
            PLLDIVRW::DIV15 => 14,
            PLLDIVRW::DIV16 => 15,
            PLLDIVRW::DIV17 => 16,
            PLLDIVRW::DIV18 => 17,
            PLLDIVRW::DIV19 => 18,
            PLLDIVRW::DIV20 => 19,
            PLLDIVRW::DIV21 => 20,
            PLLDIVRW::DIV22 => 21,
            PLLDIVRW::DIV23 => 22,
            PLLDIVRW::DIV24 => 23,
            PLLDIVRW::DIV25 => 24,
            PLLDIVRW::DIV26 => 25,
            PLLDIVRW::DIV27 => 26,
            PLLDIVRW::DIV28 => 27,
            PLLDIVRW::DIV29 => 28,
            PLLDIVRW::DIV30 => 29,
            PLLDIVRW::DIV31 => 30,
            PLLDIVRW::DIV32 => 31,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PLLDIVRW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLDIVRW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PLLDIVRW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "PLLSAIDIVQ = /1"]
    #[inline]
    pub fn div1(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV1)
    }
    #[doc = "PLLSAIDIVQ = /2"]
    #[inline]
    pub fn div2(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV2)
    }
    #[doc = "PLLSAIDIVQ = /3"]
    #[inline]
    pub fn div3(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV3)
    }
    #[doc = "PLLSAIDIVQ = /4"]
    #[inline]
    pub fn div4(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV4)
    }
    #[doc = "PLLSAIDIVQ = /5"]
    #[inline]
    pub fn div5(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV5)
    }
    #[doc = "PLLSAIDIVQ = /6"]
    #[inline]
    pub fn div6(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV6)
    }
    #[doc = "PLLSAIDIVQ = /7"]
    #[inline]
    pub fn div7(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV7)
    }
    #[doc = "PLLSAIDIVQ = /8"]
    #[inline]
    pub fn div8(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV8)
    }
    #[doc = "PLLSAIDIVQ = /9"]
    #[inline]
    pub fn div9(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV9)
    }
    #[doc = "PLLSAIDIVQ = /10"]
    #[inline]
    pub fn div10(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV10)
    }
    #[doc = "PLLSAIDIVQ = /11"]
    #[inline]
    pub fn div11(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV11)
    }
    #[doc = "PLLSAIDIVQ = /12"]
    #[inline]
    pub fn div12(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV12)
    }
    #[doc = "PLLSAIDIVQ = /13"]
    #[inline]
    pub fn div13(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV13)
    }
    #[doc = "PLLSAIDIVQ = /14"]
    #[inline]
    pub fn div14(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV14)
    }
    #[doc = "PLLSAIDIVQ = /15"]
    #[inline]
    pub fn div15(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV15)
    }
    #[doc = "PLLSAIDIVQ = /16"]
    #[inline]
    pub fn div16(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV16)
    }
    #[doc = "PLLSAIDIVQ = /17"]
    #[inline]
    pub fn div17(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV17)
    }
    #[doc = "PLLSAIDIVQ = /18"]
    #[inline]
    pub fn div18(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV18)
    }
    #[doc = "PLLSAIDIVQ = /19"]
    #[inline]
    pub fn div19(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV19)
    }
    #[doc = "PLLSAIDIVQ = /20"]
    #[inline]
    pub fn div20(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV20)
    }
    #[doc = "PLLSAIDIVQ = /21"]
    #[inline]
    pub fn div21(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV21)
    }
    #[doc = "PLLSAIDIVQ = /22"]
    #[inline]
    pub fn div22(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV22)
    }
    #[doc = "PLLSAIDIVQ = /23"]
    #[inline]
    pub fn div23(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV23)
    }
    #[doc = "PLLSAIDIVQ = /24"]
    #[inline]
    pub fn div24(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV24)
    }
    #[doc = "PLLSAIDIVQ = /25"]
    #[inline]
    pub fn div25(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV25)
    }
    #[doc = "PLLSAIDIVQ = /26"]
    #[inline]
    pub fn div26(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV26)
    }
    #[doc = "PLLSAIDIVQ = /27"]
    #[inline]
    pub fn div27(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV27)
    }
    #[doc = "PLLSAIDIVQ = /28"]
    #[inline]
    pub fn div28(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV28)
    }
    #[doc = "PLLSAIDIVQ = /29"]
    #[inline]
    pub fn div29(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV29)
    }
    #[doc = "PLLSAIDIVQ = /30"]
    #[inline]
    pub fn div30(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV30)
    }
    #[doc = "PLLSAIDIVQ = /31"]
    #[inline]
    pub fn div31(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV31)
    }
    #[doc = "PLLSAIDIVQ = /32"]
    #[inline]
    pub fn div32(self) -> &'a mut W {
        self.variant(PLLDIVRW::DIV32)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 31;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CKDFSDM2ASEL`"]
pub type CKDFSDM2ASELW = CKDFSDM1ASELW;
#[doc = r" Proxy"]
pub struct _CKDFSDM2ASELW<'a> {
    w: &'a mut W,
}
impl<'a> _CKDFSDM2ASELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CKDFSDM2ASELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "CK_I2S_APB1 selected as audio clock"]
    #[inline]
    pub fn i2s1(self) -> &'a mut W {
        self.variant(CKDFSDM1ASELW::I2S1)
    }
    #[doc = "CK_I2S_APB2 selected as audio clock"]
    #[inline]
    pub fn i2s2(self) -> &'a mut W {
        self.variant(CKDFSDM1ASELW::I2S2)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 14;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SAI1ASRC`"]
pub enum SAI1ASRCW {
    #[doc = "SAI1-A clock frequency = f(PLLSAI_Q) / PLLSAIDIVQ"]
    PLLSAI,
    #[doc = "SAI1-A clock frequency = f(PLLI2S_Q) / PLLI2SDIVQ"]
    PLLI2S,
    #[doc = "SAI1-A clock frequency = Alternate function input frequency"]
    I2S_CKIN,
}
impl SAI1ASRCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            SAI1ASRCW::PLLSAI => 0,
            SAI1ASRCW::PLLI2S => 1,
            SAI1ASRCW::I2S_CKIN => 2,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SAI1ASRCW<'a> {
    w: &'a mut W,
}
impl<'a> _SAI1ASRCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SAI1ASRCW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "SAI1-A clock frequency = f(PLLSAI_Q) / PLLSAIDIVQ"]
    #[inline]
    pub fn pllsai(self) -> &'a mut W {
        self.variant(SAI1ASRCW::PLLSAI)
    }
    #[doc = "SAI1-A clock frequency = f(PLLI2S_Q) / PLLI2SDIVQ"]
    #[inline]
    pub fn plli2s(self) -> &'a mut W {
        self.variant(SAI1ASRCW::PLLI2S)
    }
    #[doc = "SAI1-A clock frequency = Alternate function input frequency"]
    #[inline]
    pub fn i2s_ckin(self) -> &'a mut W {
        self.variant(SAI1ASRCW::I2S_CKIN)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 20;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SAI1BSRC`"]
pub enum SAI1BSRCW {
    #[doc = "SAI1-B clock frequency = f(PLLSAI_Q) / PLLSAIDIVQ"]
    PLLSAI,
    #[doc = "SAI1-B clock frequency = f(PLLI2S_Q) / PLLI2SDIVQ"]
    PLLI2S,
    #[doc = "SAI1-B clock frequency = Alternate function input frequency"]
    I2S_CKIN,
}
impl SAI1BSRCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            SAI1BSRCW::PLLSAI => 0,
            SAI1BSRCW::PLLI2S => 1,
            SAI1BSRCW::I2S_CKIN => 2,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SAI1BSRCW<'a> {
    w: &'a mut W,
}
impl<'a> _SAI1BSRCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SAI1BSRCW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "SAI1-B clock frequency = f(PLLSAI_Q) / PLLSAIDIVQ"]
    #[inline]
    pub fn pllsai(self) -> &'a mut W {
        self.variant(SAI1BSRCW::PLLSAI)
    }
    #[doc = "SAI1-B clock frequency = f(PLLI2S_Q) / PLLI2SDIVQ"]
    #[inline]
    pub fn plli2s(self) -> &'a mut W {
        self.variant(SAI1BSRCW::PLLI2S)
    }
    #[doc = "SAI1-B clock frequency = Alternate function input frequency"]
    #[inline]
    pub fn i2s_ckin(self) -> &'a mut W {
        self.variant(SAI1BSRCW::I2S_CKIN)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 22;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CKDFSDM1SEL`"]
pub enum CKDFSDM1SELW {
    #[doc = "APB2 clock used as Kernel clock"]
    APB2,
    #[doc = "System clock used as Kernel clock"]
    SYSCLK,
}
impl CKDFSDM1SELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CKDFSDM1SELW::APB2 => false,
            CKDFSDM1SELW::SYSCLK => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CKDFSDM1SELW<'a> {
    w: &'a mut W,
}
impl<'a> _CKDFSDM1SELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CKDFSDM1SELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "APB2 clock used as Kernel clock"]
    #[inline]
    pub fn apb2(self) -> &'a mut W {
        self.variant(CKDFSDM1SELW::APB2)
    }
    #[doc = "System clock used as Kernel clock"]
    #[inline]
    pub fn sysclk(self) -> &'a mut W {
        self.variant(CKDFSDM1SELW::SYSCLK)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 31;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 15 - DFSDM1 audio clock selection."]
    #[inline]
    pub fn ckdfsdm1asel(&self) -> CKDFSDM1ASELR {
        CKDFSDM1ASELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 15;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 24 - Timers clocks prescalers selection"]
    #[inline]
    pub fn timpre(&self) -> TIMPRER {
        TIMPRER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 24;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bits 25:26 - I2S APB1 clocks source selection (I2S2/3)"]
    #[inline]
    pub fn i2s1src(&self) -> I2S1SRCR {
        I2S1SRCR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 25;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 27:28 - I2S APB2 clocks source selection (I2S1/4/5)"]
    #[inline]
    pub fn i2s2src(&self) -> I2S2SRCR {
        I2S2SRCR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 27;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 0:4 - PLLI2S division factor for SAI1 A/B clock"]
    #[inline]
    pub fn plli2sdivr(&self) -> PLLI2SDIVRR {
        PLLI2SDIVRR::_from({
            const MASK: u8 = 31;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 8:12 - PLL division factor for SAI1 A/B clock"]
    #[inline]
    pub fn plldivr(&self) -> PLLDIVRR {
        PLLDIVRR::_from({
            const MASK: u8 = 31;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 14 - DFSDM2 audio clock selection"]
    #[inline]
    pub fn ckdfsdm2asel(&self) -> CKDFSDM2ASELR {
        CKDFSDM2ASELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 14;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bits 20:21 - SAI1-A clock source selection"]
    #[inline]
    pub fn sai1asrc(&self) -> SAI1ASRCR {
        SAI1ASRCR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 20;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 22:23 - SAI1-B clock source selection"]
    #[inline]
    pub fn sai1bsrc(&self) -> SAI1BSRCR {
        SAI1BSRCR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 22;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 31 - DFSDM1 Kernel clock selection"]
    #[inline]
    pub fn ckdfsdm1sel(&self) -> CKDFSDM1SELR {
        CKDFSDM1SELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 31;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 15 - DFSDM1 audio clock selection."]
    #[inline]
    pub fn ckdfsdm1asel(&mut self) -> _CKDFSDM1ASELW {
        _CKDFSDM1ASELW { w: self }
    }
    #[doc = "Bit 24 - Timers clocks prescalers selection"]
    #[inline]
    pub fn timpre(&mut self) -> _TIMPREW {
        _TIMPREW { w: self }
    }
    #[doc = "Bits 25:26 - I2S APB1 clocks source selection (I2S2/3)"]
    #[inline]
    pub fn i2s1src(&mut self) -> _I2S1SRCW {
        _I2S1SRCW { w: self }
    }
    #[doc = "Bits 27:28 - I2S APB2 clocks source selection (I2S1/4/5)"]
    #[inline]
    pub fn i2s2src(&mut self) -> _I2S2SRCW {
        _I2S2SRCW { w: self }
    }
    #[doc = "Bits 0:4 - PLLI2S division factor for SAI1 A/B clock"]
    #[inline]
    pub fn plli2sdivr(&mut self) -> _PLLI2SDIVRW {
        _PLLI2SDIVRW { w: self }
    }
    #[doc = "Bits 8:12 - PLL division factor for SAI1 A/B clock"]
    #[inline]
    pub fn plldivr(&mut self) -> _PLLDIVRW {
        _PLLDIVRW { w: self }
    }
    #[doc = "Bit 14 - DFSDM2 audio clock selection"]
    #[inline]
    pub fn ckdfsdm2asel(&mut self) -> _CKDFSDM2ASELW {
        _CKDFSDM2ASELW { w: self }
    }
    #[doc = "Bits 20:21 - SAI1-A clock source selection"]
    #[inline]
    pub fn sai1asrc(&mut self) -> _SAI1ASRCW {
        _SAI1ASRCW { w: self }
    }
    #[doc = "Bits 22:23 - SAI1-B clock source selection"]
    #[inline]
    pub fn sai1bsrc(&mut self) -> _SAI1BSRCW {
        _SAI1BSRCW { w: self }
    }
    #[doc = "Bit 31 - DFSDM1 Kernel clock selection"]
    #[inline]
    pub fn ckdfsdm1sel(&mut self) -> _CKDFSDM1SELW {
        _CKDFSDM1SELW { w: self }
    }
}
