#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::DCKCFGR2 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `SDIOSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SDIOSELR {
    #[doc = "48 MHz clock is selected as SD clock"]
    CK48M,
    #[doc = "System clock is selected as SD clock"]
    SYSCLK,
}
impl SDIOSELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SDIOSELR::CK48M => false,
            SDIOSELR::SYSCLK => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SDIOSELR {
        match value {
            false => SDIOSELR::CK48M,
            true => SDIOSELR::SYSCLK,
        }
    }
    #[doc = "Checks if the value of the field is `CK48M`"]
    #[inline]
    pub fn is_ck48m(&self) -> bool {
        *self == SDIOSELR::CK48M
    }
    #[doc = "Checks if the value of the field is `SYSCLK`"]
    #[inline]
    pub fn is_sysclk(&self) -> bool {
        *self == SDIOSELR::SYSCLK
    }
}
#[doc = "Possible values of the field `CK48MSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CK48MSELR {
    #[doc = "48MHz clock from PLL is selected"]
    PLL,
    #[doc = "48MHz clock from PLLSAI is selected"]
    PLLSAI,
}
impl CK48MSELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CK48MSELR::PLL => false,
            CK48MSELR::PLLSAI => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CK48MSELR {
        match value {
            false => CK48MSELR::PLL,
            true => CK48MSELR::PLLSAI,
        }
    }
    #[doc = "Checks if the value of the field is `PLL`"]
    #[inline]
    pub fn is_pll(&self) -> bool {
        *self == CK48MSELR::PLL
    }
    #[doc = "Checks if the value of the field is `PLLSAI`"]
    #[inline]
    pub fn is_pllsai(&self) -> bool {
        *self == CK48MSELR::PLLSAI
    }
}
#[doc = "Possible values of the field `I2CFMP1SEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum I2CFMP1SELR {
    #[doc = "APB clock selected as FMPI2C1 clock"]
    APB,
    #[doc = "System clock selected as FMPI2C1 clock"]
    SYSCLK,
    #[doc = "HSI clock selected as FMPI2C1 clock"]
    HSI,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl I2CFMP1SELR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            I2CFMP1SELR::APB => 0,
            I2CFMP1SELR::SYSCLK => 1,
            I2CFMP1SELR::HSI => 2,
            I2CFMP1SELR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> I2CFMP1SELR {
        match value {
            0 => I2CFMP1SELR::APB,
            1 => I2CFMP1SELR::SYSCLK,
            2 => I2CFMP1SELR::HSI,
            i => I2CFMP1SELR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `APB`"]
    #[inline]
    pub fn is_apb(&self) -> bool {
        *self == I2CFMP1SELR::APB
    }
    #[doc = "Checks if the value of the field is `SYSCLK`"]
    #[inline]
    pub fn is_sysclk(&self) -> bool {
        *self == I2CFMP1SELR::SYSCLK
    }
    #[doc = "Checks if the value of the field is `HSI`"]
    #[inline]
    pub fn is_hsi(&self) -> bool {
        *self == I2CFMP1SELR::HSI
    }
}
#[doc = "Possible values of the field `LPTIM1SEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum LPTIM1SELR {
    #[doc = "APB1 clock (PCLK1) selected as LPTILM1 clock"]
    APB1,
    #[doc = "LSI clock is selected as LPTILM1 clock"]
    LSI,
    #[doc = "HSI clock is selected as LPTILM1 clock"]
    HSI,
    #[doc = "LSE clock is selected as LPTILM1 clock"]
    LSE,
}
impl LPTIM1SELR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            LPTIM1SELR::APB1 => 0,
            LPTIM1SELR::LSI => 1,
            LPTIM1SELR::HSI => 2,
            LPTIM1SELR::LSE => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> LPTIM1SELR {
        match value {
            0 => LPTIM1SELR::APB1,
            1 => LPTIM1SELR::LSI,
            2 => LPTIM1SELR::HSI,
            3 => LPTIM1SELR::LSE,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `APB1`"]
    #[inline]
    pub fn is_apb1(&self) -> bool {
        *self == LPTIM1SELR::APB1
    }
    #[doc = "Checks if the value of the field is `LSI`"]
    #[inline]
    pub fn is_lsi(&self) -> bool {
        *self == LPTIM1SELR::LSI
    }
    #[doc = "Checks if the value of the field is `HSI`"]
    #[inline]
    pub fn is_hsi(&self) -> bool {
        *self == LPTIM1SELR::HSI
    }
    #[doc = "Checks if the value of the field is `LSE`"]
    #[inline]
    pub fn is_lse(&self) -> bool {
        *self == LPTIM1SELR::LSE
    }
}
#[doc = "Values that can be written to the field `SDIOSEL`"]
pub enum SDIOSELW {
    #[doc = "48 MHz clock is selected as SD clock"]
    CK48M,
    #[doc = "System clock is selected as SD clock"]
    SYSCLK,
}
impl SDIOSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            SDIOSELW::CK48M => false,
            SDIOSELW::SYSCLK => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SDIOSELW<'a> {
    w: &'a mut W,
}
impl<'a> _SDIOSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SDIOSELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "48 MHz clock is selected as SD clock"]
    #[inline]
    pub fn ck48m(self) -> &'a mut W {
        self.variant(SDIOSELW::CK48M)
    }
    #[doc = "System clock is selected as SD clock"]
    #[inline]
    pub fn sysclk(self) -> &'a mut W {
        self.variant(SDIOSELW::SYSCLK)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 28;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CK48MSEL`"]
pub enum CK48MSELW {
    #[doc = "48MHz clock from PLL is selected"]
    PLL,
    #[doc = "48MHz clock from PLLSAI is selected"]
    PLLSAI,
}
impl CK48MSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CK48MSELW::PLL => false,
            CK48MSELW::PLLSAI => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CK48MSELW<'a> {
    w: &'a mut W,
}
impl<'a> _CK48MSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CK48MSELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "48MHz clock from PLL is selected"]
    #[inline]
    pub fn pll(self) -> &'a mut W {
        self.variant(CK48MSELW::PLL)
    }
    #[doc = "48MHz clock from PLLSAI is selected"]
    #[inline]
    pub fn pllsai(self) -> &'a mut W {
        self.variant(CK48MSELW::PLLSAI)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 27;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `I2CFMP1SEL`"]
pub enum I2CFMP1SELW {
    #[doc = "APB clock selected as FMPI2C1 clock"]
    APB,
    #[doc = "System clock selected as FMPI2C1 clock"]
    SYSCLK,
    #[doc = "HSI clock selected as FMPI2C1 clock"]
    HSI,
}
impl I2CFMP1SELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            I2CFMP1SELW::APB => 0,
            I2CFMP1SELW::SYSCLK => 1,
            I2CFMP1SELW::HSI => 2,
        }
    }
}
#[doc = r" Proxy"]
pub struct _I2CFMP1SELW<'a> {
    w: &'a mut W,
}
impl<'a> _I2CFMP1SELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: I2CFMP1SELW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "APB clock selected as FMPI2C1 clock"]
    #[inline]
    pub fn apb(self) -> &'a mut W {
        self.variant(I2CFMP1SELW::APB)
    }
    #[doc = "System clock selected as FMPI2C1 clock"]
    #[inline]
    pub fn sysclk(self) -> &'a mut W {
        self.variant(I2CFMP1SELW::SYSCLK)
    }
    #[doc = "HSI clock selected as FMPI2C1 clock"]
    #[inline]
    pub fn hsi(self) -> &'a mut W {
        self.variant(I2CFMP1SELW::HSI)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 22;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `LPTIM1SEL`"]
pub enum LPTIM1SELW {
    #[doc = "APB1 clock (PCLK1) selected as LPTILM1 clock"]
    APB1,
    #[doc = "LSI clock is selected as LPTILM1 clock"]
    LSI,
    #[doc = "HSI clock is selected as LPTILM1 clock"]
    HSI,
    #[doc = "LSE clock is selected as LPTILM1 clock"]
    LSE,
}
impl LPTIM1SELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            LPTIM1SELW::APB1 => 0,
            LPTIM1SELW::LSI => 1,
            LPTIM1SELW::HSI => 2,
            LPTIM1SELW::LSE => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _LPTIM1SELW<'a> {
    w: &'a mut W,
}
impl<'a> _LPTIM1SELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: LPTIM1SELW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "APB1 clock (PCLK1) selected as LPTILM1 clock"]
    #[inline]
    pub fn apb1(self) -> &'a mut W {
        self.variant(LPTIM1SELW::APB1)
    }
    #[doc = "LSI clock is selected as LPTILM1 clock"]
    #[inline]
    pub fn lsi(self) -> &'a mut W {
        self.variant(LPTIM1SELW::LSI)
    }
    #[doc = "HSI clock is selected as LPTILM1 clock"]
    #[inline]
    pub fn hsi(self) -> &'a mut W {
        self.variant(LPTIM1SELW::HSI)
    }
    #[doc = "LSE clock is selected as LPTILM1 clock"]
    #[inline]
    pub fn lse(self) -> &'a mut W {
        self.variant(LPTIM1SELW::LSE)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 30;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 28 - SDIO clock selection."]
    #[inline]
    pub fn sdiosel(&self) -> SDIOSELR {
        SDIOSELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 28;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 27 - SDIO/USBFS clock selection."]
    #[inline]
    pub fn ck48msel(&self) -> CK48MSELR {
        CK48MSELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 27;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bits 22:23 - I2CFMP1 kernel clock source selection"]
    #[inline]
    pub fn i2cfmp1sel(&self) -> I2CFMP1SELR {
        I2CFMP1SELR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 22;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 30:31 - LPTIM1 kernel clock source selection"]
    #[inline]
    pub fn lptim1sel(&self) -> LPTIM1SELR {
        LPTIM1SELR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 30;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 28 - SDIO clock selection."]
    #[inline]
    pub fn sdiosel(&mut self) -> _SDIOSELW {
        _SDIOSELW { w: self }
    }
    #[doc = "Bit 27 - SDIO/USBFS clock selection."]
    #[inline]
    pub fn ck48msel(&mut self) -> _CK48MSELW {
        _CK48MSELW { w: self }
    }
    #[doc = "Bits 22:23 - I2CFMP1 kernel clock source selection"]
    #[inline]
    pub fn i2cfmp1sel(&mut self) -> _I2CFMP1SELW {
        _I2CFMP1SELW { w: self }
    }
    #[doc = "Bits 30:31 - LPTIM1 kernel clock source selection"]
    #[inline]
    pub fn lptim1sel(&mut self) -> _LPTIM1SELW {
        _LPTIM1SELW { w: self }
    }
}
