#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::DCKCFGR2 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `I2CFMP1SEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum I2CFMP1SELR {
    #[doc = "APB clock selected as FMPI2C1 clock"]
    APB,
    #[doc = "System clock selected as FMPI2C1 clock"]
    SYSCLK,
    #[doc = "HSI clock selected as FMPI2C1 clock"]
    HSI,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl I2CFMP1SELR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            I2CFMP1SELR::APB => 0,
            I2CFMP1SELR::SYSCLK => 1,
            I2CFMP1SELR::HSI => 2,
            I2CFMP1SELR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> I2CFMP1SELR {
        match value {
            0 => I2CFMP1SELR::APB,
            1 => I2CFMP1SELR::SYSCLK,
            2 => I2CFMP1SELR::HSI,
            i => I2CFMP1SELR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `APB`"]
    #[inline]
    pub fn is_apb(&self) -> bool {
        *self == I2CFMP1SELR::APB
    }
    #[doc = "Checks if the value of the field is `SYSCLK`"]
    #[inline]
    pub fn is_sysclk(&self) -> bool {
        *self == I2CFMP1SELR::SYSCLK
    }
    #[doc = "Checks if the value of the field is `HSI`"]
    #[inline]
    pub fn is_hsi(&self) -> bool {
        *self == I2CFMP1SELR::HSI
    }
}
#[doc = "Possible values of the field `CECSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CECSELR {
    #[doc = "LSE clock is selected as HDMI-CEC clock"]
    LSE,
    #[doc = "HSI divided by 488 clock is selected as HDMI-CEC clock"]
    HSI_DIV488,
}
impl CECSELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CECSELR::LSE => false,
            CECSELR::HSI_DIV488 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CECSELR {
        match value {
            false => CECSELR::LSE,
            true => CECSELR::HSI_DIV488,
        }
    }
    #[doc = "Checks if the value of the field is `LSE`"]
    #[inline]
    pub fn is_lse(&self) -> bool {
        *self == CECSELR::LSE
    }
    #[doc = "Checks if the value of the field is `HSI_DIV488`"]
    #[inline]
    pub fn is_hsi_div488(&self) -> bool {
        *self == CECSELR::HSI_DIV488
    }
}
#[doc = "Possible values of the field `CK48MSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CK48MSELR {
    #[doc = "48MHz clock from PLL is selected"]
    PLL,
    #[doc = "48MHz clock from PLLSAI is selected"]
    PLLSAI,
}
impl CK48MSELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            CK48MSELR::PLL => false,
            CK48MSELR::PLLSAI => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> CK48MSELR {
        match value {
            false => CK48MSELR::PLL,
            true => CK48MSELR::PLLSAI,
        }
    }
    #[doc = "Checks if the value of the field is `PLL`"]
    #[inline]
    pub fn is_pll(&self) -> bool {
        *self == CK48MSELR::PLL
    }
    #[doc = "Checks if the value of the field is `PLLSAI`"]
    #[inline]
    pub fn is_pllsai(&self) -> bool {
        *self == CK48MSELR::PLLSAI
    }
}
#[doc = "Possible values of the field `SDIOSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SDIOSELR {
    #[doc = "48 MHz clock is selected as SD clock"]
    CK48M,
    #[doc = "System clock is selected as SD clock"]
    SYSCLK,
}
impl SDIOSELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SDIOSELR::CK48M => false,
            SDIOSELR::SYSCLK => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SDIOSELR {
        match value {
            false => SDIOSELR::CK48M,
            true => SDIOSELR::SYSCLK,
        }
    }
    #[doc = "Checks if the value of the field is `CK48M`"]
    #[inline]
    pub fn is_ck48m(&self) -> bool {
        *self == SDIOSELR::CK48M
    }
    #[doc = "Checks if the value of the field is `SYSCLK`"]
    #[inline]
    pub fn is_sysclk(&self) -> bool {
        *self == SDIOSELR::SYSCLK
    }
}
#[doc = "Possible values of the field `SPDIFRXSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SPDIFRXSELR {
    #[doc = "SPDIF-Rx clock from PLL is selected"]
    PLL,
    #[doc = "SPDIF-Rx clock from PLLI2S is selected"]
    PLLI2S,
}
impl SPDIFRXSELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SPDIFRXSELR::PLL => false,
            SPDIFRXSELR::PLLI2S => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SPDIFRXSELR {
        match value {
            false => SPDIFRXSELR::PLL,
            true => SPDIFRXSELR::PLLI2S,
        }
    }
    #[doc = "Checks if the value of the field is `PLL`"]
    #[inline]
    pub fn is_pll(&self) -> bool {
        *self == SPDIFRXSELR::PLL
    }
    #[doc = "Checks if the value of the field is `PLLI2S`"]
    #[inline]
    pub fn is_plli2s(&self) -> bool {
        *self == SPDIFRXSELR::PLLI2S
    }
}
#[doc = "Values that can be written to the field `I2CFMP1SEL`"]
pub enum I2CFMP1SELW {
    #[doc = "APB clock selected as FMPI2C1 clock"]
    APB,
    #[doc = "System clock selected as FMPI2C1 clock"]
    SYSCLK,
    #[doc = "HSI clock selected as FMPI2C1 clock"]
    HSI,
}
impl I2CFMP1SELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            I2CFMP1SELW::APB => 0,
            I2CFMP1SELW::SYSCLK => 1,
            I2CFMP1SELW::HSI => 2,
        }
    }
}
#[doc = r" Proxy"]
pub struct _I2CFMP1SELW<'a> {
    w: &'a mut W,
}
impl<'a> _I2CFMP1SELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: I2CFMP1SELW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "APB clock selected as FMPI2C1 clock"]
    #[inline]
    pub fn apb(self) -> &'a mut W {
        self.variant(I2CFMP1SELW::APB)
    }
    #[doc = "System clock selected as FMPI2C1 clock"]
    #[inline]
    pub fn sysclk(self) -> &'a mut W {
        self.variant(I2CFMP1SELW::SYSCLK)
    }
    #[doc = "HSI clock selected as FMPI2C1 clock"]
    #[inline]
    pub fn hsi(self) -> &'a mut W {
        self.variant(I2CFMP1SELW::HSI)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 22;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CECSEL`"]
pub enum CECSELW {
    #[doc = "LSE clock is selected as HDMI-CEC clock"]
    LSE,
    #[doc = "HSI divided by 488 clock is selected as HDMI-CEC clock"]
    HSI_DIV488,
}
impl CECSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CECSELW::LSE => false,
            CECSELW::HSI_DIV488 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CECSELW<'a> {
    w: &'a mut W,
}
impl<'a> _CECSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CECSELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "LSE clock is selected as HDMI-CEC clock"]
    #[inline]
    pub fn lse(self) -> &'a mut W {
        self.variant(CECSELW::LSE)
    }
    #[doc = "HSI divided by 488 clock is selected as HDMI-CEC clock"]
    #[inline]
    pub fn hsi_div488(self) -> &'a mut W {
        self.variant(CECSELW::HSI_DIV488)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 26;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `CK48MSEL`"]
pub enum CK48MSELW {
    #[doc = "48MHz clock from PLL is selected"]
    PLL,
    #[doc = "48MHz clock from PLLSAI is selected"]
    PLLSAI,
}
impl CK48MSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            CK48MSELW::PLL => false,
            CK48MSELW::PLLSAI => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _CK48MSELW<'a> {
    w: &'a mut W,
}
impl<'a> _CK48MSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: CK48MSELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "48MHz clock from PLL is selected"]
    #[inline]
    pub fn pll(self) -> &'a mut W {
        self.variant(CK48MSELW::PLL)
    }
    #[doc = "48MHz clock from PLLSAI is selected"]
    #[inline]
    pub fn pllsai(self) -> &'a mut W {
        self.variant(CK48MSELW::PLLSAI)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 27;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SDIOSEL`"]
pub enum SDIOSELW {
    #[doc = "48 MHz clock is selected as SD clock"]
    CK48M,
    #[doc = "System clock is selected as SD clock"]
    SYSCLK,
}
impl SDIOSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            SDIOSELW::CK48M => false,
            SDIOSELW::SYSCLK => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SDIOSELW<'a> {
    w: &'a mut W,
}
impl<'a> _SDIOSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SDIOSELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "48 MHz clock is selected as SD clock"]
    #[inline]
    pub fn ck48m(self) -> &'a mut W {
        self.variant(SDIOSELW::CK48M)
    }
    #[doc = "System clock is selected as SD clock"]
    #[inline]
    pub fn sysclk(self) -> &'a mut W {
        self.variant(SDIOSELW::SYSCLK)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 28;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SPDIFRXSEL`"]
pub enum SPDIFRXSELW {
    #[doc = "SPDIF-Rx clock from PLL is selected"]
    PLL,
    #[doc = "SPDIF-Rx clock from PLLI2S is selected"]
    PLLI2S,
}
impl SPDIFRXSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            SPDIFRXSELW::PLL => false,
            SPDIFRXSELW::PLLI2S => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SPDIFRXSELW<'a> {
    w: &'a mut W,
}
impl<'a> _SPDIFRXSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SPDIFRXSELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "SPDIF-Rx clock from PLL is selected"]
    #[inline]
    pub fn pll(self) -> &'a mut W {
        self.variant(SPDIFRXSELW::PLL)
    }
    #[doc = "SPDIF-Rx clock from PLLI2S is selected"]
    #[inline]
    pub fn plli2s(self) -> &'a mut W {
        self.variant(SPDIFRXSELW::PLLI2S)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 29;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 22:23 - I2C4 kernel clock source selection"]
    #[inline]
    pub fn i2cfmp1sel(&self) -> I2CFMP1SELR {
        I2CFMP1SELR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 22;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 26 - HDMI CEC clock source selection"]
    #[inline]
    pub fn cecsel(&self) -> CECSELR {
        CECSELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 26;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 27 - SDIO/USBFS/HS clock selection"]
    #[inline]
    pub fn ck48msel(&self) -> CK48MSELR {
        CK48MSELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 27;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 28 - SDIO clock selection"]
    #[inline]
    pub fn sdiosel(&self) -> SDIOSELR {
        SDIOSELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 28;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 29 - SPDIF clock selection"]
    #[inline]
    pub fn spdifrxsel(&self) -> SPDIFRXSELR {
        SPDIFRXSELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 29;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 22:23 - I2C4 kernel clock source selection"]
    #[inline]
    pub fn i2cfmp1sel(&mut self) -> _I2CFMP1SELW {
        _I2CFMP1SELW { w: self }
    }
    #[doc = "Bit 26 - HDMI CEC clock source selection"]
    #[inline]
    pub fn cecsel(&mut self) -> _CECSELW {
        _CECSELW { w: self }
    }
    #[doc = "Bit 27 - SDIO/USBFS/HS clock selection"]
    #[inline]
    pub fn ck48msel(&mut self) -> _CK48MSELW {
        _CK48MSELW { w: self }
    }
    #[doc = "Bit 28 - SDIO clock selection"]
    #[inline]
    pub fn sdiosel(&mut self) -> _SDIOSELW {
        _SDIOSELW { w: self }
    }
    #[doc = "Bit 29 - SPDIF clock selection"]
    #[inline]
    pub fn spdifrxsel(&mut self) -> _SPDIFRXSELW {
        _SPDIFRXSELW { w: self }
    }
}
