#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::DCKCFGR {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `PLLI2SDIVQ`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLLI2SDIVQR {
    #[doc = "PLLI2SDIVQ = /1"]
    DIV1,
    #[doc = "PLLI2SDIVQ = /2"]
    DIV2,
    #[doc = "PLLI2SDIVQ = /3"]
    DIV3,
    #[doc = "PLLI2SDIVQ = /4"]
    DIV4,
    #[doc = "PLLI2SDIVQ = /5"]
    DIV5,
    #[doc = "PLLI2SDIVQ = /6"]
    DIV6,
    #[doc = "PLLI2SDIVQ = /7"]
    DIV7,
    #[doc = "PLLI2SDIVQ = /8"]
    DIV8,
    #[doc = "PLLI2SDIVQ = /9"]
    DIV9,
    #[doc = "PLLI2SDIVQ = /10"]
    DIV10,
    #[doc = "PLLI2SDIVQ = /11"]
    DIV11,
    #[doc = "PLLI2SDIVQ = /12"]
    DIV12,
    #[doc = "PLLI2SDIVQ = /13"]
    DIV13,
    #[doc = "PLLI2SDIVQ = /14"]
    DIV14,
    #[doc = "PLLI2SDIVQ = /15"]
    DIV15,
    #[doc = "PLLI2SDIVQ = /16"]
    DIV16,
    #[doc = "PLLI2SDIVQ = /17"]
    DIV17,
    #[doc = "PLLI2SDIVQ = /18"]
    DIV18,
    #[doc = "PLLI2SDIVQ = /19"]
    DIV19,
    #[doc = "PLLI2SDIVQ = /20"]
    DIV20,
    #[doc = "PLLI2SDIVQ = /21"]
    DIV21,
    #[doc = "PLLI2SDIVQ = /22"]
    DIV22,
    #[doc = "PLLI2SDIVQ = /23"]
    DIV23,
    #[doc = "PLLI2SDIVQ = /24"]
    DIV24,
    #[doc = "PLLI2SDIVQ = /25"]
    DIV25,
    #[doc = "PLLI2SDIVQ = /26"]
    DIV26,
    #[doc = "PLLI2SDIVQ = /27"]
    DIV27,
    #[doc = "PLLI2SDIVQ = /28"]
    DIV28,
    #[doc = "PLLI2SDIVQ = /29"]
    DIV29,
    #[doc = "PLLI2SDIVQ = /30"]
    DIV30,
    #[doc = "PLLI2SDIVQ = /31"]
    DIV31,
    #[doc = "PLLI2SDIVQ = /32"]
    DIV32,
}
impl PLLI2SDIVQR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            PLLI2SDIVQR::DIV1 => 0,
            PLLI2SDIVQR::DIV2 => 1,
            PLLI2SDIVQR::DIV3 => 2,
            PLLI2SDIVQR::DIV4 => 3,
            PLLI2SDIVQR::DIV5 => 4,
            PLLI2SDIVQR::DIV6 => 5,
            PLLI2SDIVQR::DIV7 => 6,
            PLLI2SDIVQR::DIV8 => 7,
            PLLI2SDIVQR::DIV9 => 8,
            PLLI2SDIVQR::DIV10 => 9,
            PLLI2SDIVQR::DIV11 => 10,
            PLLI2SDIVQR::DIV12 => 11,
            PLLI2SDIVQR::DIV13 => 12,
            PLLI2SDIVQR::DIV14 => 13,
            PLLI2SDIVQR::DIV15 => 14,
            PLLI2SDIVQR::DIV16 => 15,
            PLLI2SDIVQR::DIV17 => 16,
            PLLI2SDIVQR::DIV18 => 17,
            PLLI2SDIVQR::DIV19 => 18,
            PLLI2SDIVQR::DIV20 => 19,
            PLLI2SDIVQR::DIV21 => 20,
            PLLI2SDIVQR::DIV22 => 21,
            PLLI2SDIVQR::DIV23 => 22,
            PLLI2SDIVQR::DIV24 => 23,
            PLLI2SDIVQR::DIV25 => 24,
            PLLI2SDIVQR::DIV26 => 25,
            PLLI2SDIVQR::DIV27 => 26,
            PLLI2SDIVQR::DIV28 => 27,
            PLLI2SDIVQR::DIV29 => 28,
            PLLI2SDIVQR::DIV30 => 29,
            PLLI2SDIVQR::DIV31 => 30,
            PLLI2SDIVQR::DIV32 => 31,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> PLLI2SDIVQR {
        match value {
            0 => PLLI2SDIVQR::DIV1,
            1 => PLLI2SDIVQR::DIV2,
            2 => PLLI2SDIVQR::DIV3,
            3 => PLLI2SDIVQR::DIV4,
            4 => PLLI2SDIVQR::DIV5,
            5 => PLLI2SDIVQR::DIV6,
            6 => PLLI2SDIVQR::DIV7,
            7 => PLLI2SDIVQR::DIV8,
            8 => PLLI2SDIVQR::DIV9,
            9 => PLLI2SDIVQR::DIV10,
            10 => PLLI2SDIVQR::DIV11,
            11 => PLLI2SDIVQR::DIV12,
            12 => PLLI2SDIVQR::DIV13,
            13 => PLLI2SDIVQR::DIV14,
            14 => PLLI2SDIVQR::DIV15,
            15 => PLLI2SDIVQR::DIV16,
            16 => PLLI2SDIVQR::DIV17,
            17 => PLLI2SDIVQR::DIV18,
            18 => PLLI2SDIVQR::DIV19,
            19 => PLLI2SDIVQR::DIV20,
            20 => PLLI2SDIVQR::DIV21,
            21 => PLLI2SDIVQR::DIV22,
            22 => PLLI2SDIVQR::DIV23,
            23 => PLLI2SDIVQR::DIV24,
            24 => PLLI2SDIVQR::DIV25,
            25 => PLLI2SDIVQR::DIV26,
            26 => PLLI2SDIVQR::DIV27,
            27 => PLLI2SDIVQR::DIV28,
            28 => PLLI2SDIVQR::DIV29,
            29 => PLLI2SDIVQR::DIV30,
            30 => PLLI2SDIVQR::DIV31,
            31 => PLLI2SDIVQR::DIV32,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DIV1`"]
    #[inline]
    pub fn is_div1(&self) -> bool {
        *self == PLLI2SDIVQR::DIV1
    }
    #[doc = "Checks if the value of the field is `DIV2`"]
    #[inline]
    pub fn is_div2(&self) -> bool {
        *self == PLLI2SDIVQR::DIV2
    }
    #[doc = "Checks if the value of the field is `DIV3`"]
    #[inline]
    pub fn is_div3(&self) -> bool {
        *self == PLLI2SDIVQR::DIV3
    }
    #[doc = "Checks if the value of the field is `DIV4`"]
    #[inline]
    pub fn is_div4(&self) -> bool {
        *self == PLLI2SDIVQR::DIV4
    }
    #[doc = "Checks if the value of the field is `DIV5`"]
    #[inline]
    pub fn is_div5(&self) -> bool {
        *self == PLLI2SDIVQR::DIV5
    }
    #[doc = "Checks if the value of the field is `DIV6`"]
    #[inline]
    pub fn is_div6(&self) -> bool {
        *self == PLLI2SDIVQR::DIV6
    }
    #[doc = "Checks if the value of the field is `DIV7`"]
    #[inline]
    pub fn is_div7(&self) -> bool {
        *self == PLLI2SDIVQR::DIV7
    }
    #[doc = "Checks if the value of the field is `DIV8`"]
    #[inline]
    pub fn is_div8(&self) -> bool {
        *self == PLLI2SDIVQR::DIV8
    }
    #[doc = "Checks if the value of the field is `DIV9`"]
    #[inline]
    pub fn is_div9(&self) -> bool {
        *self == PLLI2SDIVQR::DIV9
    }
    #[doc = "Checks if the value of the field is `DIV10`"]
    #[inline]
    pub fn is_div10(&self) -> bool {
        *self == PLLI2SDIVQR::DIV10
    }
    #[doc = "Checks if the value of the field is `DIV11`"]
    #[inline]
    pub fn is_div11(&self) -> bool {
        *self == PLLI2SDIVQR::DIV11
    }
    #[doc = "Checks if the value of the field is `DIV12`"]
    #[inline]
    pub fn is_div12(&self) -> bool {
        *self == PLLI2SDIVQR::DIV12
    }
    #[doc = "Checks if the value of the field is `DIV13`"]
    #[inline]
    pub fn is_div13(&self) -> bool {
        *self == PLLI2SDIVQR::DIV13
    }
    #[doc = "Checks if the value of the field is `DIV14`"]
    #[inline]
    pub fn is_div14(&self) -> bool {
        *self == PLLI2SDIVQR::DIV14
    }
    #[doc = "Checks if the value of the field is `DIV15`"]
    #[inline]
    pub fn is_div15(&self) -> bool {
        *self == PLLI2SDIVQR::DIV15
    }
    #[doc = "Checks if the value of the field is `DIV16`"]
    #[inline]
    pub fn is_div16(&self) -> bool {
        *self == PLLI2SDIVQR::DIV16
    }
    #[doc = "Checks if the value of the field is `DIV17`"]
    #[inline]
    pub fn is_div17(&self) -> bool {
        *self == PLLI2SDIVQR::DIV17
    }
    #[doc = "Checks if the value of the field is `DIV18`"]
    #[inline]
    pub fn is_div18(&self) -> bool {
        *self == PLLI2SDIVQR::DIV18
    }
    #[doc = "Checks if the value of the field is `DIV19`"]
    #[inline]
    pub fn is_div19(&self) -> bool {
        *self == PLLI2SDIVQR::DIV19
    }
    #[doc = "Checks if the value of the field is `DIV20`"]
    #[inline]
    pub fn is_div20(&self) -> bool {
        *self == PLLI2SDIVQR::DIV20
    }
    #[doc = "Checks if the value of the field is `DIV21`"]
    #[inline]
    pub fn is_div21(&self) -> bool {
        *self == PLLI2SDIVQR::DIV21
    }
    #[doc = "Checks if the value of the field is `DIV22`"]
    #[inline]
    pub fn is_div22(&self) -> bool {
        *self == PLLI2SDIVQR::DIV22
    }
    #[doc = "Checks if the value of the field is `DIV23`"]
    #[inline]
    pub fn is_div23(&self) -> bool {
        *self == PLLI2SDIVQR::DIV23
    }
    #[doc = "Checks if the value of the field is `DIV24`"]
    #[inline]
    pub fn is_div24(&self) -> bool {
        *self == PLLI2SDIVQR::DIV24
    }
    #[doc = "Checks if the value of the field is `DIV25`"]
    #[inline]
    pub fn is_div25(&self) -> bool {
        *self == PLLI2SDIVQR::DIV25
    }
    #[doc = "Checks if the value of the field is `DIV26`"]
    #[inline]
    pub fn is_div26(&self) -> bool {
        *self == PLLI2SDIVQR::DIV26
    }
    #[doc = "Checks if the value of the field is `DIV27`"]
    #[inline]
    pub fn is_div27(&self) -> bool {
        *self == PLLI2SDIVQR::DIV27
    }
    #[doc = "Checks if the value of the field is `DIV28`"]
    #[inline]
    pub fn is_div28(&self) -> bool {
        *self == PLLI2SDIVQR::DIV28
    }
    #[doc = "Checks if the value of the field is `DIV29`"]
    #[inline]
    pub fn is_div29(&self) -> bool {
        *self == PLLI2SDIVQR::DIV29
    }
    #[doc = "Checks if the value of the field is `DIV30`"]
    #[inline]
    pub fn is_div30(&self) -> bool {
        *self == PLLI2SDIVQR::DIV30
    }
    #[doc = "Checks if the value of the field is `DIV31`"]
    #[inline]
    pub fn is_div31(&self) -> bool {
        *self == PLLI2SDIVQR::DIV31
    }
    #[doc = "Checks if the value of the field is `DIV32`"]
    #[inline]
    pub fn is_div32(&self) -> bool {
        *self == PLLI2SDIVQR::DIV32
    }
}
#[doc = "Possible values of the field `PLLSAIDIVQ`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLLSAIDIVQR {
    #[doc = "PLLSAIDIVQ = /1"]
    DIV1,
    #[doc = "PLLSAIDIVQ = /2"]
    DIV2,
    #[doc = "PLLSAIDIVQ = /3"]
    DIV3,
    #[doc = "PLLSAIDIVQ = /4"]
    DIV4,
    #[doc = "PLLSAIDIVQ = /5"]
    DIV5,
    #[doc = "PLLSAIDIVQ = /6"]
    DIV6,
    #[doc = "PLLSAIDIVQ = /7"]
    DIV7,
    #[doc = "PLLSAIDIVQ = /8"]
    DIV8,
    #[doc = "PLLSAIDIVQ = /9"]
    DIV9,
    #[doc = "PLLSAIDIVQ = /10"]
    DIV10,
    #[doc = "PLLSAIDIVQ = /11"]
    DIV11,
    #[doc = "PLLSAIDIVQ = /12"]
    DIV12,
    #[doc = "PLLSAIDIVQ = /13"]
    DIV13,
    #[doc = "PLLSAIDIVQ = /14"]
    DIV14,
    #[doc = "PLLSAIDIVQ = /15"]
    DIV15,
    #[doc = "PLLSAIDIVQ = /16"]
    DIV16,
    #[doc = "PLLSAIDIVQ = /17"]
    DIV17,
    #[doc = "PLLSAIDIVQ = /18"]
    DIV18,
    #[doc = "PLLSAIDIVQ = /19"]
    DIV19,
    #[doc = "PLLSAIDIVQ = /20"]
    DIV20,
    #[doc = "PLLSAIDIVQ = /21"]
    DIV21,
    #[doc = "PLLSAIDIVQ = /22"]
    DIV22,
    #[doc = "PLLSAIDIVQ = /23"]
    DIV23,
    #[doc = "PLLSAIDIVQ = /24"]
    DIV24,
    #[doc = "PLLSAIDIVQ = /25"]
    DIV25,
    #[doc = "PLLSAIDIVQ = /26"]
    DIV26,
    #[doc = "PLLSAIDIVQ = /27"]
    DIV27,
    #[doc = "PLLSAIDIVQ = /28"]
    DIV28,
    #[doc = "PLLSAIDIVQ = /29"]
    DIV29,
    #[doc = "PLLSAIDIVQ = /30"]
    DIV30,
    #[doc = "PLLSAIDIVQ = /31"]
    DIV31,
    #[doc = "PLLSAIDIVQ = /32"]
    DIV32,
}
impl PLLSAIDIVQR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            PLLSAIDIVQR::DIV1 => 0,
            PLLSAIDIVQR::DIV2 => 1,
            PLLSAIDIVQR::DIV3 => 2,
            PLLSAIDIVQR::DIV4 => 3,
            PLLSAIDIVQR::DIV5 => 4,
            PLLSAIDIVQR::DIV6 => 5,
            PLLSAIDIVQR::DIV7 => 6,
            PLLSAIDIVQR::DIV8 => 7,
            PLLSAIDIVQR::DIV9 => 8,
            PLLSAIDIVQR::DIV10 => 9,
            PLLSAIDIVQR::DIV11 => 10,
            PLLSAIDIVQR::DIV12 => 11,
            PLLSAIDIVQR::DIV13 => 12,
            PLLSAIDIVQR::DIV14 => 13,
            PLLSAIDIVQR::DIV15 => 14,
            PLLSAIDIVQR::DIV16 => 15,
            PLLSAIDIVQR::DIV17 => 16,
            PLLSAIDIVQR::DIV18 => 17,
            PLLSAIDIVQR::DIV19 => 18,
            PLLSAIDIVQR::DIV20 => 19,
            PLLSAIDIVQR::DIV21 => 20,
            PLLSAIDIVQR::DIV22 => 21,
            PLLSAIDIVQR::DIV23 => 22,
            PLLSAIDIVQR::DIV24 => 23,
            PLLSAIDIVQR::DIV25 => 24,
            PLLSAIDIVQR::DIV26 => 25,
            PLLSAIDIVQR::DIV27 => 26,
            PLLSAIDIVQR::DIV28 => 27,
            PLLSAIDIVQR::DIV29 => 28,
            PLLSAIDIVQR::DIV30 => 29,
            PLLSAIDIVQR::DIV31 => 30,
            PLLSAIDIVQR::DIV32 => 31,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> PLLSAIDIVQR {
        match value {
            0 => PLLSAIDIVQR::DIV1,
            1 => PLLSAIDIVQR::DIV2,
            2 => PLLSAIDIVQR::DIV3,
            3 => PLLSAIDIVQR::DIV4,
            4 => PLLSAIDIVQR::DIV5,
            5 => PLLSAIDIVQR::DIV6,
            6 => PLLSAIDIVQR::DIV7,
            7 => PLLSAIDIVQR::DIV8,
            8 => PLLSAIDIVQR::DIV9,
            9 => PLLSAIDIVQR::DIV10,
            10 => PLLSAIDIVQR::DIV11,
            11 => PLLSAIDIVQR::DIV12,
            12 => PLLSAIDIVQR::DIV13,
            13 => PLLSAIDIVQR::DIV14,
            14 => PLLSAIDIVQR::DIV15,
            15 => PLLSAIDIVQR::DIV16,
            16 => PLLSAIDIVQR::DIV17,
            17 => PLLSAIDIVQR::DIV18,
            18 => PLLSAIDIVQR::DIV19,
            19 => PLLSAIDIVQR::DIV20,
            20 => PLLSAIDIVQR::DIV21,
            21 => PLLSAIDIVQR::DIV22,
            22 => PLLSAIDIVQR::DIV23,
            23 => PLLSAIDIVQR::DIV24,
            24 => PLLSAIDIVQR::DIV25,
            25 => PLLSAIDIVQR::DIV26,
            26 => PLLSAIDIVQR::DIV27,
            27 => PLLSAIDIVQR::DIV28,
            28 => PLLSAIDIVQR::DIV29,
            29 => PLLSAIDIVQR::DIV30,
            30 => PLLSAIDIVQR::DIV31,
            31 => PLLSAIDIVQR::DIV32,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DIV1`"]
    #[inline]
    pub fn is_div1(&self) -> bool {
        *self == PLLSAIDIVQR::DIV1
    }
    #[doc = "Checks if the value of the field is `DIV2`"]
    #[inline]
    pub fn is_div2(&self) -> bool {
        *self == PLLSAIDIVQR::DIV2
    }
    #[doc = "Checks if the value of the field is `DIV3`"]
    #[inline]
    pub fn is_div3(&self) -> bool {
        *self == PLLSAIDIVQR::DIV3
    }
    #[doc = "Checks if the value of the field is `DIV4`"]
    #[inline]
    pub fn is_div4(&self) -> bool {
        *self == PLLSAIDIVQR::DIV4
    }
    #[doc = "Checks if the value of the field is `DIV5`"]
    #[inline]
    pub fn is_div5(&self) -> bool {
        *self == PLLSAIDIVQR::DIV5
    }
    #[doc = "Checks if the value of the field is `DIV6`"]
    #[inline]
    pub fn is_div6(&self) -> bool {
        *self == PLLSAIDIVQR::DIV6
    }
    #[doc = "Checks if the value of the field is `DIV7`"]
    #[inline]
    pub fn is_div7(&self) -> bool {
        *self == PLLSAIDIVQR::DIV7
    }
    #[doc = "Checks if the value of the field is `DIV8`"]
    #[inline]
    pub fn is_div8(&self) -> bool {
        *self == PLLSAIDIVQR::DIV8
    }
    #[doc = "Checks if the value of the field is `DIV9`"]
    #[inline]
    pub fn is_div9(&self) -> bool {
        *self == PLLSAIDIVQR::DIV9
    }
    #[doc = "Checks if the value of the field is `DIV10`"]
    #[inline]
    pub fn is_div10(&self) -> bool {
        *self == PLLSAIDIVQR::DIV10
    }
    #[doc = "Checks if the value of the field is `DIV11`"]
    #[inline]
    pub fn is_div11(&self) -> bool {
        *self == PLLSAIDIVQR::DIV11
    }
    #[doc = "Checks if the value of the field is `DIV12`"]
    #[inline]
    pub fn is_div12(&self) -> bool {
        *self == PLLSAIDIVQR::DIV12
    }
    #[doc = "Checks if the value of the field is `DIV13`"]
    #[inline]
    pub fn is_div13(&self) -> bool {
        *self == PLLSAIDIVQR::DIV13
    }
    #[doc = "Checks if the value of the field is `DIV14`"]
    #[inline]
    pub fn is_div14(&self) -> bool {
        *self == PLLSAIDIVQR::DIV14
    }
    #[doc = "Checks if the value of the field is `DIV15`"]
    #[inline]
    pub fn is_div15(&self) -> bool {
        *self == PLLSAIDIVQR::DIV15
    }
    #[doc = "Checks if the value of the field is `DIV16`"]
    #[inline]
    pub fn is_div16(&self) -> bool {
        *self == PLLSAIDIVQR::DIV16
    }
    #[doc = "Checks if the value of the field is `DIV17`"]
    #[inline]
    pub fn is_div17(&self) -> bool {
        *self == PLLSAIDIVQR::DIV17
    }
    #[doc = "Checks if the value of the field is `DIV18`"]
    #[inline]
    pub fn is_div18(&self) -> bool {
        *self == PLLSAIDIVQR::DIV18
    }
    #[doc = "Checks if the value of the field is `DIV19`"]
    #[inline]
    pub fn is_div19(&self) -> bool {
        *self == PLLSAIDIVQR::DIV19
    }
    #[doc = "Checks if the value of the field is `DIV20`"]
    #[inline]
    pub fn is_div20(&self) -> bool {
        *self == PLLSAIDIVQR::DIV20
    }
    #[doc = "Checks if the value of the field is `DIV21`"]
    #[inline]
    pub fn is_div21(&self) -> bool {
        *self == PLLSAIDIVQR::DIV21
    }
    #[doc = "Checks if the value of the field is `DIV22`"]
    #[inline]
    pub fn is_div22(&self) -> bool {
        *self == PLLSAIDIVQR::DIV22
    }
    #[doc = "Checks if the value of the field is `DIV23`"]
    #[inline]
    pub fn is_div23(&self) -> bool {
        *self == PLLSAIDIVQR::DIV23
    }
    #[doc = "Checks if the value of the field is `DIV24`"]
    #[inline]
    pub fn is_div24(&self) -> bool {
        *self == PLLSAIDIVQR::DIV24
    }
    #[doc = "Checks if the value of the field is `DIV25`"]
    #[inline]
    pub fn is_div25(&self) -> bool {
        *self == PLLSAIDIVQR::DIV25
    }
    #[doc = "Checks if the value of the field is `DIV26`"]
    #[inline]
    pub fn is_div26(&self) -> bool {
        *self == PLLSAIDIVQR::DIV26
    }
    #[doc = "Checks if the value of the field is `DIV27`"]
    #[inline]
    pub fn is_div27(&self) -> bool {
        *self == PLLSAIDIVQR::DIV27
    }
    #[doc = "Checks if the value of the field is `DIV28`"]
    #[inline]
    pub fn is_div28(&self) -> bool {
        *self == PLLSAIDIVQR::DIV28
    }
    #[doc = "Checks if the value of the field is `DIV29`"]
    #[inline]
    pub fn is_div29(&self) -> bool {
        *self == PLLSAIDIVQR::DIV29
    }
    #[doc = "Checks if the value of the field is `DIV30`"]
    #[inline]
    pub fn is_div30(&self) -> bool {
        *self == PLLSAIDIVQR::DIV30
    }
    #[doc = "Checks if the value of the field is `DIV31`"]
    #[inline]
    pub fn is_div31(&self) -> bool {
        *self == PLLSAIDIVQR::DIV31
    }
    #[doc = "Checks if the value of the field is `DIV32`"]
    #[inline]
    pub fn is_div32(&self) -> bool {
        *self == PLLSAIDIVQR::DIV32
    }
}
#[doc = "Possible values of the field `PLLSAIDIVR`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLLSAIDIVRR {
    #[doc = "PLLSAIDIVR = /2"]
    DIV2,
    #[doc = "PLLSAIDIVR = /4"]
    DIV4,
    #[doc = "PLLSAIDIVR = /8"]
    DIV8,
    #[doc = "PLLSAIDIVR = /16"]
    DIV16,
}
impl PLLSAIDIVRR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            PLLSAIDIVRR::DIV2 => 0,
            PLLSAIDIVRR::DIV4 => 1,
            PLLSAIDIVRR::DIV8 => 2,
            PLLSAIDIVRR::DIV16 => 3,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> PLLSAIDIVRR {
        match value {
            0 => PLLSAIDIVRR::DIV2,
            1 => PLLSAIDIVRR::DIV4,
            2 => PLLSAIDIVRR::DIV8,
            3 => PLLSAIDIVRR::DIV16,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DIV2`"]
    #[inline]
    pub fn is_div2(&self) -> bool {
        *self == PLLSAIDIVRR::DIV2
    }
    #[doc = "Checks if the value of the field is `DIV4`"]
    #[inline]
    pub fn is_div4(&self) -> bool {
        *self == PLLSAIDIVRR::DIV4
    }
    #[doc = "Checks if the value of the field is `DIV8`"]
    #[inline]
    pub fn is_div8(&self) -> bool {
        *self == PLLSAIDIVRR::DIV8
    }
    #[doc = "Checks if the value of the field is `DIV16`"]
    #[inline]
    pub fn is_div16(&self) -> bool {
        *self == PLLSAIDIVRR::DIV16
    }
}
#[doc = "Possible values of the field `SAI1ASRC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SAI1ASRCR {
    #[doc = "SAI1-A clock frequency = f(PLLSAI_Q) / PLLSAIDIVQ"]
    PLLSAI,
    #[doc = "SAI1-A clock frequency = f(PLLI2S_Q) / PLLI2SDIVQ"]
    PLLI2S,
    #[doc = "SAI1-A clock frequency = Alternate function input frequency"]
    I2S_CKIN,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl SAI1ASRCR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            SAI1ASRCR::PLLSAI => 0,
            SAI1ASRCR::PLLI2S => 1,
            SAI1ASRCR::I2S_CKIN => 2,
            SAI1ASRCR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> SAI1ASRCR {
        match value {
            0 => SAI1ASRCR::PLLSAI,
            1 => SAI1ASRCR::PLLI2S,
            2 => SAI1ASRCR::I2S_CKIN,
            i => SAI1ASRCR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `PLLSAI`"]
    #[inline]
    pub fn is_pllsai(&self) -> bool {
        *self == SAI1ASRCR::PLLSAI
    }
    #[doc = "Checks if the value of the field is `PLLI2S`"]
    #[inline]
    pub fn is_plli2s(&self) -> bool {
        *self == SAI1ASRCR::PLLI2S
    }
    #[doc = "Checks if the value of the field is `I2S_CKIN`"]
    #[inline]
    pub fn is_i2s_ckin(&self) -> bool {
        *self == SAI1ASRCR::I2S_CKIN
    }
}
#[doc = "Possible values of the field `SAI1BSRC`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SAI1BSRCR {
    #[doc = "SAI1-B clock frequency = f(PLLSAI_Q) / PLLSAIDIVQ"]
    PLLSAI,
    #[doc = "SAI1-B clock frequency = f(PLLI2S_Q) / PLLI2SDIVQ"]
    PLLI2S,
    #[doc = "SAI1-B clock frequency = Alternate function input frequency"]
    I2S_CKIN,
    #[doc = r" Reserved"]
    _Reserved(u8),
}
impl SAI1BSRCR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        match *self {
            SAI1BSRCR::PLLSAI => 0,
            SAI1BSRCR::PLLI2S => 1,
            SAI1BSRCR::I2S_CKIN => 2,
            SAI1BSRCR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: u8) -> SAI1BSRCR {
        match value {
            0 => SAI1BSRCR::PLLSAI,
            1 => SAI1BSRCR::PLLI2S,
            2 => SAI1BSRCR::I2S_CKIN,
            i => SAI1BSRCR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `PLLSAI`"]
    #[inline]
    pub fn is_pllsai(&self) -> bool {
        *self == SAI1BSRCR::PLLSAI
    }
    #[doc = "Checks if the value of the field is `PLLI2S`"]
    #[inline]
    pub fn is_plli2s(&self) -> bool {
        *self == SAI1BSRCR::PLLI2S
    }
    #[doc = "Checks if the value of the field is `I2S_CKIN`"]
    #[inline]
    pub fn is_i2s_ckin(&self) -> bool {
        *self == SAI1BSRCR::I2S_CKIN
    }
}
#[doc = "Possible values of the field `TIMPRE`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum TIMPRER {
    #[doc = "If the APB prescaler is configured 1, TIMxCLK = PCLKx. Otherwise, TIMxCLK = 2xPCLKx"]
    MUL2,
    #[doc = "If the APB prescaler is configured 1, 2 or 4, TIMxCLK = HCLK. Otherwise, TIMxCLK = 4xPCLKx"]
    MUL4,
}
impl TIMPRER {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            TIMPRER::MUL2 => false,
            TIMPRER::MUL4 => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> TIMPRER {
        match value {
            false => TIMPRER::MUL2,
            true => TIMPRER::MUL4,
        }
    }
    #[doc = "Checks if the value of the field is `MUL2`"]
    #[inline]
    pub fn is_mul2(&self) -> bool {
        *self == TIMPRER::MUL2
    }
    #[doc = "Checks if the value of the field is `MUL4`"]
    #[inline]
    pub fn is_mul4(&self) -> bool {
        *self == TIMPRER::MUL4
    }
}
#[doc = "Possible values of the field `48MSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum _48MSELR {
    #[doc = "48MHz clock from PLL is selected"]
    PLL,
    #[doc = "48MHz clock from PLLSAI is selected"]
    PLLSAI,
}
impl _48MSELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            _48MSELR::PLL => false,
            _48MSELR::PLLSAI => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> _48MSELR {
        match value {
            false => _48MSELR::PLL,
            true => _48MSELR::PLLSAI,
        }
    }
    #[doc = "Checks if the value of the field is `PLL`"]
    #[inline]
    pub fn is_pll(&self) -> bool {
        *self == _48MSELR::PLL
    }
    #[doc = "Checks if the value of the field is `PLLSAI`"]
    #[inline]
    pub fn is_pllsai(&self) -> bool {
        *self == _48MSELR::PLLSAI
    }
}
#[doc = "Possible values of the field `SDIOSEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum SDIOSELR {
    #[doc = "48 MHz clock is selected as SD clock"]
    CK48M,
    #[doc = "System clock is selected as SD clock"]
    SYSCLK,
}
impl SDIOSELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            SDIOSELR::CK48M => false,
            SDIOSELR::SYSCLK => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> SDIOSELR {
        match value {
            false => SDIOSELR::CK48M,
            true => SDIOSELR::SYSCLK,
        }
    }
    #[doc = "Checks if the value of the field is `CK48M`"]
    #[inline]
    pub fn is_ck48m(&self) -> bool {
        *self == SDIOSELR::CK48M
    }
    #[doc = "Checks if the value of the field is `SYSCLK`"]
    #[inline]
    pub fn is_sysclk(&self) -> bool {
        *self == SDIOSELR::SYSCLK
    }
}
#[doc = "Possible values of the field `DSISEL`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum DSISELR {
    #[doc = "DSI-PHY used as DSI byte lane clock source (usual case)"]
    DSI_PHY,
    #[doc = "PLLR used as DSI byte lane clock source, used in case DSI PLL and DSI-PHY are off (low power mode)"]
    PLLR,
}
impl DSISELR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            DSISELR::DSI_PHY => false,
            DSISELR::PLLR => true,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> DSISELR {
        match value {
            false => DSISELR::DSI_PHY,
            true => DSISELR::PLLR,
        }
    }
    #[doc = "Checks if the value of the field is `DSI_PHY`"]
    #[inline]
    pub fn is_dsi_phy(&self) -> bool {
        *self == DSISELR::DSI_PHY
    }
    #[doc = "Checks if the value of the field is `PLLR`"]
    #[inline]
    pub fn is_pllr(&self) -> bool {
        *self == DSISELR::PLLR
    }
}
#[doc = "Values that can be written to the field `PLLI2SDIVQ`"]
pub enum PLLI2SDIVQW {
    #[doc = "PLLI2SDIVQ = /1"]
    DIV1,
    #[doc = "PLLI2SDIVQ = /2"]
    DIV2,
    #[doc = "PLLI2SDIVQ = /3"]
    DIV3,
    #[doc = "PLLI2SDIVQ = /4"]
    DIV4,
    #[doc = "PLLI2SDIVQ = /5"]
    DIV5,
    #[doc = "PLLI2SDIVQ = /6"]
    DIV6,
    #[doc = "PLLI2SDIVQ = /7"]
    DIV7,
    #[doc = "PLLI2SDIVQ = /8"]
    DIV8,
    #[doc = "PLLI2SDIVQ = /9"]
    DIV9,
    #[doc = "PLLI2SDIVQ = /10"]
    DIV10,
    #[doc = "PLLI2SDIVQ = /11"]
    DIV11,
    #[doc = "PLLI2SDIVQ = /12"]
    DIV12,
    #[doc = "PLLI2SDIVQ = /13"]
    DIV13,
    #[doc = "PLLI2SDIVQ = /14"]
    DIV14,
    #[doc = "PLLI2SDIVQ = /15"]
    DIV15,
    #[doc = "PLLI2SDIVQ = /16"]
    DIV16,
    #[doc = "PLLI2SDIVQ = /17"]
    DIV17,
    #[doc = "PLLI2SDIVQ = /18"]
    DIV18,
    #[doc = "PLLI2SDIVQ = /19"]
    DIV19,
    #[doc = "PLLI2SDIVQ = /20"]
    DIV20,
    #[doc = "PLLI2SDIVQ = /21"]
    DIV21,
    #[doc = "PLLI2SDIVQ = /22"]
    DIV22,
    #[doc = "PLLI2SDIVQ = /23"]
    DIV23,
    #[doc = "PLLI2SDIVQ = /24"]
    DIV24,
    #[doc = "PLLI2SDIVQ = /25"]
    DIV25,
    #[doc = "PLLI2SDIVQ = /26"]
    DIV26,
    #[doc = "PLLI2SDIVQ = /27"]
    DIV27,
    #[doc = "PLLI2SDIVQ = /28"]
    DIV28,
    #[doc = "PLLI2SDIVQ = /29"]
    DIV29,
    #[doc = "PLLI2SDIVQ = /30"]
    DIV30,
    #[doc = "PLLI2SDIVQ = /31"]
    DIV31,
    #[doc = "PLLI2SDIVQ = /32"]
    DIV32,
}
impl PLLI2SDIVQW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            PLLI2SDIVQW::DIV1 => 0,
            PLLI2SDIVQW::DIV2 => 1,
            PLLI2SDIVQW::DIV3 => 2,
            PLLI2SDIVQW::DIV4 => 3,
            PLLI2SDIVQW::DIV5 => 4,
            PLLI2SDIVQW::DIV6 => 5,
            PLLI2SDIVQW::DIV7 => 6,
            PLLI2SDIVQW::DIV8 => 7,
            PLLI2SDIVQW::DIV9 => 8,
            PLLI2SDIVQW::DIV10 => 9,
            PLLI2SDIVQW::DIV11 => 10,
            PLLI2SDIVQW::DIV12 => 11,
            PLLI2SDIVQW::DIV13 => 12,
            PLLI2SDIVQW::DIV14 => 13,
            PLLI2SDIVQW::DIV15 => 14,
            PLLI2SDIVQW::DIV16 => 15,
            PLLI2SDIVQW::DIV17 => 16,
            PLLI2SDIVQW::DIV18 => 17,
            PLLI2SDIVQW::DIV19 => 18,
            PLLI2SDIVQW::DIV20 => 19,
            PLLI2SDIVQW::DIV21 => 20,
            PLLI2SDIVQW::DIV22 => 21,
            PLLI2SDIVQW::DIV23 => 22,
            PLLI2SDIVQW::DIV24 => 23,
            PLLI2SDIVQW::DIV25 => 24,
            PLLI2SDIVQW::DIV26 => 25,
            PLLI2SDIVQW::DIV27 => 26,
            PLLI2SDIVQW::DIV28 => 27,
            PLLI2SDIVQW::DIV29 => 28,
            PLLI2SDIVQW::DIV30 => 29,
            PLLI2SDIVQW::DIV31 => 30,
            PLLI2SDIVQW::DIV32 => 31,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PLLI2SDIVQW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLI2SDIVQW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PLLI2SDIVQW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "PLLI2SDIVQ = /1"]
    #[inline]
    pub fn div1(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV1)
    }
    #[doc = "PLLI2SDIVQ = /2"]
    #[inline]
    pub fn div2(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV2)
    }
    #[doc = "PLLI2SDIVQ = /3"]
    #[inline]
    pub fn div3(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV3)
    }
    #[doc = "PLLI2SDIVQ = /4"]
    #[inline]
    pub fn div4(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV4)
    }
    #[doc = "PLLI2SDIVQ = /5"]
    #[inline]
    pub fn div5(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV5)
    }
    #[doc = "PLLI2SDIVQ = /6"]
    #[inline]
    pub fn div6(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV6)
    }
    #[doc = "PLLI2SDIVQ = /7"]
    #[inline]
    pub fn div7(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV7)
    }
    #[doc = "PLLI2SDIVQ = /8"]
    #[inline]
    pub fn div8(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV8)
    }
    #[doc = "PLLI2SDIVQ = /9"]
    #[inline]
    pub fn div9(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV9)
    }
    #[doc = "PLLI2SDIVQ = /10"]
    #[inline]
    pub fn div10(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV10)
    }
    #[doc = "PLLI2SDIVQ = /11"]
    #[inline]
    pub fn div11(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV11)
    }
    #[doc = "PLLI2SDIVQ = /12"]
    #[inline]
    pub fn div12(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV12)
    }
    #[doc = "PLLI2SDIVQ = /13"]
    #[inline]
    pub fn div13(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV13)
    }
    #[doc = "PLLI2SDIVQ = /14"]
    #[inline]
    pub fn div14(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV14)
    }
    #[doc = "PLLI2SDIVQ = /15"]
    #[inline]
    pub fn div15(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV15)
    }
    #[doc = "PLLI2SDIVQ = /16"]
    #[inline]
    pub fn div16(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV16)
    }
    #[doc = "PLLI2SDIVQ = /17"]
    #[inline]
    pub fn div17(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV17)
    }
    #[doc = "PLLI2SDIVQ = /18"]
    #[inline]
    pub fn div18(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV18)
    }
    #[doc = "PLLI2SDIVQ = /19"]
    #[inline]
    pub fn div19(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV19)
    }
    #[doc = "PLLI2SDIVQ = /20"]
    #[inline]
    pub fn div20(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV20)
    }
    #[doc = "PLLI2SDIVQ = /21"]
    #[inline]
    pub fn div21(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV21)
    }
    #[doc = "PLLI2SDIVQ = /22"]
    #[inline]
    pub fn div22(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV22)
    }
    #[doc = "PLLI2SDIVQ = /23"]
    #[inline]
    pub fn div23(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV23)
    }
    #[doc = "PLLI2SDIVQ = /24"]
    #[inline]
    pub fn div24(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV24)
    }
    #[doc = "PLLI2SDIVQ = /25"]
    #[inline]
    pub fn div25(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV25)
    }
    #[doc = "PLLI2SDIVQ = /26"]
    #[inline]
    pub fn div26(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV26)
    }
    #[doc = "PLLI2SDIVQ = /27"]
    #[inline]
    pub fn div27(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV27)
    }
    #[doc = "PLLI2SDIVQ = /28"]
    #[inline]
    pub fn div28(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV28)
    }
    #[doc = "PLLI2SDIVQ = /29"]
    #[inline]
    pub fn div29(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV29)
    }
    #[doc = "PLLI2SDIVQ = /30"]
    #[inline]
    pub fn div30(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV30)
    }
    #[doc = "PLLI2SDIVQ = /31"]
    #[inline]
    pub fn div31(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV31)
    }
    #[doc = "PLLI2SDIVQ = /32"]
    #[inline]
    pub fn div32(self) -> &'a mut W {
        self.variant(PLLI2SDIVQW::DIV32)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 31;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PLLSAIDIVQ`"]
pub enum PLLSAIDIVQW {
    #[doc = "PLLSAIDIVQ = /1"]
    DIV1,
    #[doc = "PLLSAIDIVQ = /2"]
    DIV2,
    #[doc = "PLLSAIDIVQ = /3"]
    DIV3,
    #[doc = "PLLSAIDIVQ = /4"]
    DIV4,
    #[doc = "PLLSAIDIVQ = /5"]
    DIV5,
    #[doc = "PLLSAIDIVQ = /6"]
    DIV6,
    #[doc = "PLLSAIDIVQ = /7"]
    DIV7,
    #[doc = "PLLSAIDIVQ = /8"]
    DIV8,
    #[doc = "PLLSAIDIVQ = /9"]
    DIV9,
    #[doc = "PLLSAIDIVQ = /10"]
    DIV10,
    #[doc = "PLLSAIDIVQ = /11"]
    DIV11,
    #[doc = "PLLSAIDIVQ = /12"]
    DIV12,
    #[doc = "PLLSAIDIVQ = /13"]
    DIV13,
    #[doc = "PLLSAIDIVQ = /14"]
    DIV14,
    #[doc = "PLLSAIDIVQ = /15"]
    DIV15,
    #[doc = "PLLSAIDIVQ = /16"]
    DIV16,
    #[doc = "PLLSAIDIVQ = /17"]
    DIV17,
    #[doc = "PLLSAIDIVQ = /18"]
    DIV18,
    #[doc = "PLLSAIDIVQ = /19"]
    DIV19,
    #[doc = "PLLSAIDIVQ = /20"]
    DIV20,
    #[doc = "PLLSAIDIVQ = /21"]
    DIV21,
    #[doc = "PLLSAIDIVQ = /22"]
    DIV22,
    #[doc = "PLLSAIDIVQ = /23"]
    DIV23,
    #[doc = "PLLSAIDIVQ = /24"]
    DIV24,
    #[doc = "PLLSAIDIVQ = /25"]
    DIV25,
    #[doc = "PLLSAIDIVQ = /26"]
    DIV26,
    #[doc = "PLLSAIDIVQ = /27"]
    DIV27,
    #[doc = "PLLSAIDIVQ = /28"]
    DIV28,
    #[doc = "PLLSAIDIVQ = /29"]
    DIV29,
    #[doc = "PLLSAIDIVQ = /30"]
    DIV30,
    #[doc = "PLLSAIDIVQ = /31"]
    DIV31,
    #[doc = "PLLSAIDIVQ = /32"]
    DIV32,
}
impl PLLSAIDIVQW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            PLLSAIDIVQW::DIV1 => 0,
            PLLSAIDIVQW::DIV2 => 1,
            PLLSAIDIVQW::DIV3 => 2,
            PLLSAIDIVQW::DIV4 => 3,
            PLLSAIDIVQW::DIV5 => 4,
            PLLSAIDIVQW::DIV6 => 5,
            PLLSAIDIVQW::DIV7 => 6,
            PLLSAIDIVQW::DIV8 => 7,
            PLLSAIDIVQW::DIV9 => 8,
            PLLSAIDIVQW::DIV10 => 9,
            PLLSAIDIVQW::DIV11 => 10,
            PLLSAIDIVQW::DIV12 => 11,
            PLLSAIDIVQW::DIV13 => 12,
            PLLSAIDIVQW::DIV14 => 13,
            PLLSAIDIVQW::DIV15 => 14,
            PLLSAIDIVQW::DIV16 => 15,
            PLLSAIDIVQW::DIV17 => 16,
            PLLSAIDIVQW::DIV18 => 17,
            PLLSAIDIVQW::DIV19 => 18,
            PLLSAIDIVQW::DIV20 => 19,
            PLLSAIDIVQW::DIV21 => 20,
            PLLSAIDIVQW::DIV22 => 21,
            PLLSAIDIVQW::DIV23 => 22,
            PLLSAIDIVQW::DIV24 => 23,
            PLLSAIDIVQW::DIV25 => 24,
            PLLSAIDIVQW::DIV26 => 25,
            PLLSAIDIVQW::DIV27 => 26,
            PLLSAIDIVQW::DIV28 => 27,
            PLLSAIDIVQW::DIV29 => 28,
            PLLSAIDIVQW::DIV30 => 29,
            PLLSAIDIVQW::DIV31 => 30,
            PLLSAIDIVQW::DIV32 => 31,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PLLSAIDIVQW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLSAIDIVQW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PLLSAIDIVQW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "PLLSAIDIVQ = /1"]
    #[inline]
    pub fn div1(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV1)
    }
    #[doc = "PLLSAIDIVQ = /2"]
    #[inline]
    pub fn div2(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV2)
    }
    #[doc = "PLLSAIDIVQ = /3"]
    #[inline]
    pub fn div3(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV3)
    }
    #[doc = "PLLSAIDIVQ = /4"]
    #[inline]
    pub fn div4(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV4)
    }
    #[doc = "PLLSAIDIVQ = /5"]
    #[inline]
    pub fn div5(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV5)
    }
    #[doc = "PLLSAIDIVQ = /6"]
    #[inline]
    pub fn div6(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV6)
    }
    #[doc = "PLLSAIDIVQ = /7"]
    #[inline]
    pub fn div7(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV7)
    }
    #[doc = "PLLSAIDIVQ = /8"]
    #[inline]
    pub fn div8(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV8)
    }
    #[doc = "PLLSAIDIVQ = /9"]
    #[inline]
    pub fn div9(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV9)
    }
    #[doc = "PLLSAIDIVQ = /10"]
    #[inline]
    pub fn div10(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV10)
    }
    #[doc = "PLLSAIDIVQ = /11"]
    #[inline]
    pub fn div11(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV11)
    }
    #[doc = "PLLSAIDIVQ = /12"]
    #[inline]
    pub fn div12(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV12)
    }
    #[doc = "PLLSAIDIVQ = /13"]
    #[inline]
    pub fn div13(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV13)
    }
    #[doc = "PLLSAIDIVQ = /14"]
    #[inline]
    pub fn div14(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV14)
    }
    #[doc = "PLLSAIDIVQ = /15"]
    #[inline]
    pub fn div15(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV15)
    }
    #[doc = "PLLSAIDIVQ = /16"]
    #[inline]
    pub fn div16(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV16)
    }
    #[doc = "PLLSAIDIVQ = /17"]
    #[inline]
    pub fn div17(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV17)
    }
    #[doc = "PLLSAIDIVQ = /18"]
    #[inline]
    pub fn div18(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV18)
    }
    #[doc = "PLLSAIDIVQ = /19"]
    #[inline]
    pub fn div19(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV19)
    }
    #[doc = "PLLSAIDIVQ = /20"]
    #[inline]
    pub fn div20(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV20)
    }
    #[doc = "PLLSAIDIVQ = /21"]
    #[inline]
    pub fn div21(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV21)
    }
    #[doc = "PLLSAIDIVQ = /22"]
    #[inline]
    pub fn div22(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV22)
    }
    #[doc = "PLLSAIDIVQ = /23"]
    #[inline]
    pub fn div23(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV23)
    }
    #[doc = "PLLSAIDIVQ = /24"]
    #[inline]
    pub fn div24(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV24)
    }
    #[doc = "PLLSAIDIVQ = /25"]
    #[inline]
    pub fn div25(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV25)
    }
    #[doc = "PLLSAIDIVQ = /26"]
    #[inline]
    pub fn div26(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV26)
    }
    #[doc = "PLLSAIDIVQ = /27"]
    #[inline]
    pub fn div27(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV27)
    }
    #[doc = "PLLSAIDIVQ = /28"]
    #[inline]
    pub fn div28(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV28)
    }
    #[doc = "PLLSAIDIVQ = /29"]
    #[inline]
    pub fn div29(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV29)
    }
    #[doc = "PLLSAIDIVQ = /30"]
    #[inline]
    pub fn div30(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV30)
    }
    #[doc = "PLLSAIDIVQ = /31"]
    #[inline]
    pub fn div31(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV31)
    }
    #[doc = "PLLSAIDIVQ = /32"]
    #[inline]
    pub fn div32(self) -> &'a mut W {
        self.variant(PLLSAIDIVQW::DIV32)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 31;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `PLLSAIDIVR`"]
pub enum PLLSAIDIVRW {
    #[doc = "PLLSAIDIVR = /2"]
    DIV2,
    #[doc = "PLLSAIDIVR = /4"]
    DIV4,
    #[doc = "PLLSAIDIVR = /8"]
    DIV8,
    #[doc = "PLLSAIDIVR = /16"]
    DIV16,
}
impl PLLSAIDIVRW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            PLLSAIDIVRW::DIV2 => 0,
            PLLSAIDIVRW::DIV4 => 1,
            PLLSAIDIVRW::DIV8 => 2,
            PLLSAIDIVRW::DIV16 => 3,
        }
    }
}
#[doc = r" Proxy"]
pub struct _PLLSAIDIVRW<'a> {
    w: &'a mut W,
}
impl<'a> _PLLSAIDIVRW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: PLLSAIDIVRW) -> &'a mut W {
        {
            self.bits(variant._bits())
        }
    }
    #[doc = "PLLSAIDIVR = /2"]
    #[inline]
    pub fn div2(self) -> &'a mut W {
        self.variant(PLLSAIDIVRW::DIV2)
    }
    #[doc = "PLLSAIDIVR = /4"]
    #[inline]
    pub fn div4(self) -> &'a mut W {
        self.variant(PLLSAIDIVRW::DIV4)
    }
    #[doc = "PLLSAIDIVR = /8"]
    #[inline]
    pub fn div8(self) -> &'a mut W {
        self.variant(PLLSAIDIVRW::DIV8)
    }
    #[doc = "PLLSAIDIVR = /16"]
    #[inline]
    pub fn div16(self) -> &'a mut W {
        self.variant(PLLSAIDIVRW::DIV16)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 16;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SAI1ASRC`"]
pub enum SAI1ASRCW {
    #[doc = "SAI1-A clock frequency = f(PLLSAI_Q) / PLLSAIDIVQ"]
    PLLSAI,
    #[doc = "SAI1-A clock frequency = f(PLLI2S_Q) / PLLI2SDIVQ"]
    PLLI2S,
    #[doc = "SAI1-A clock frequency = Alternate function input frequency"]
    I2S_CKIN,
}
impl SAI1ASRCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            SAI1ASRCW::PLLSAI => 0,
            SAI1ASRCW::PLLI2S => 1,
            SAI1ASRCW::I2S_CKIN => 2,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SAI1ASRCW<'a> {
    w: &'a mut W,
}
impl<'a> _SAI1ASRCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SAI1ASRCW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "SAI1-A clock frequency = f(PLLSAI_Q) / PLLSAIDIVQ"]
    #[inline]
    pub fn pllsai(self) -> &'a mut W {
        self.variant(SAI1ASRCW::PLLSAI)
    }
    #[doc = "SAI1-A clock frequency = f(PLLI2S_Q) / PLLI2SDIVQ"]
    #[inline]
    pub fn plli2s(self) -> &'a mut W {
        self.variant(SAI1ASRCW::PLLI2S)
    }
    #[doc = "SAI1-A clock frequency = Alternate function input frequency"]
    #[inline]
    pub fn i2s_ckin(self) -> &'a mut W {
        self.variant(SAI1ASRCW::I2S_CKIN)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 20;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SAI1BSRC`"]
pub enum SAI1BSRCW {
    #[doc = "SAI1-B clock frequency = f(PLLSAI_Q) / PLLSAIDIVQ"]
    PLLSAI,
    #[doc = "SAI1-B clock frequency = f(PLLI2S_Q) / PLLI2SDIVQ"]
    PLLI2S,
    #[doc = "SAI1-B clock frequency = Alternate function input frequency"]
    I2S_CKIN,
}
impl SAI1BSRCW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> u8 {
        match *self {
            SAI1BSRCW::PLLSAI => 0,
            SAI1BSRCW::PLLI2S => 1,
            SAI1BSRCW::I2S_CKIN => 2,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SAI1BSRCW<'a> {
    w: &'a mut W,
}
impl<'a> _SAI1BSRCW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SAI1BSRCW) -> &'a mut W {
        unsafe { self.bits(variant._bits()) }
    }
    #[doc = "SAI1-B clock frequency = f(PLLSAI_Q) / PLLSAIDIVQ"]
    #[inline]
    pub fn pllsai(self) -> &'a mut W {
        self.variant(SAI1BSRCW::PLLSAI)
    }
    #[doc = "SAI1-B clock frequency = f(PLLI2S_Q) / PLLI2SDIVQ"]
    #[inline]
    pub fn plli2s(self) -> &'a mut W {
        self.variant(SAI1BSRCW::PLLI2S)
    }
    #[doc = "SAI1-B clock frequency = Alternate function input frequency"]
    #[inline]
    pub fn i2s_ckin(self) -> &'a mut W {
        self.variant(SAI1BSRCW::I2S_CKIN)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 22;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `TIMPRE`"]
pub enum TIMPREW {
    #[doc = "If the APB prescaler is configured 1, TIMxCLK = PCLKx. Otherwise, TIMxCLK = 2xPCLKx"]
    MUL2,
    #[doc = "If the APB prescaler is configured 1, 2 or 4, TIMxCLK = HCLK. Otherwise, TIMxCLK = 4xPCLKx"]
    MUL4,
}
impl TIMPREW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            TIMPREW::MUL2 => false,
            TIMPREW::MUL4 => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _TIMPREW<'a> {
    w: &'a mut W,
}
impl<'a> _TIMPREW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: TIMPREW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "If the APB prescaler is configured 1, TIMxCLK = PCLKx. Otherwise, TIMxCLK = 2xPCLKx"]
    #[inline]
    pub fn mul2(self) -> &'a mut W {
        self.variant(TIMPREW::MUL2)
    }
    #[doc = "If the APB prescaler is configured 1, 2 or 4, TIMxCLK = HCLK. Otherwise, TIMxCLK = 4xPCLKx"]
    #[inline]
    pub fn mul4(self) -> &'a mut W {
        self.variant(TIMPREW::MUL4)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 24;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `48MSEL`"]
pub enum _48MSELW {
    #[doc = "48MHz clock from PLL is selected"]
    PLL,
    #[doc = "48MHz clock from PLLSAI is selected"]
    PLLSAI,
}
impl _48MSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            _48MSELW::PLL => false,
            _48MSELW::PLLSAI => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct __48MSELW<'a> {
    w: &'a mut W,
}
impl<'a> __48MSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: _48MSELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "48MHz clock from PLL is selected"]
    #[inline]
    pub fn pll(self) -> &'a mut W {
        self.variant(_48MSELW::PLL)
    }
    #[doc = "48MHz clock from PLLSAI is selected"]
    #[inline]
    pub fn pllsai(self) -> &'a mut W {
        self.variant(_48MSELW::PLLSAI)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 27;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `SDIOSEL`"]
pub enum SDIOSELW {
    #[doc = "48 MHz clock is selected as SD clock"]
    CK48M,
    #[doc = "System clock is selected as SD clock"]
    SYSCLK,
}
impl SDIOSELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            SDIOSELW::CK48M => false,
            SDIOSELW::SYSCLK => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _SDIOSELW<'a> {
    w: &'a mut W,
}
impl<'a> _SDIOSELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: SDIOSELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "48 MHz clock is selected as SD clock"]
    #[inline]
    pub fn ck48m(self) -> &'a mut W {
        self.variant(SDIOSELW::CK48M)
    }
    #[doc = "System clock is selected as SD clock"]
    #[inline]
    pub fn sysclk(self) -> &'a mut W {
        self.variant(SDIOSELW::SYSCLK)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 28;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `DSISEL`"]
pub enum DSISELW {
    #[doc = "DSI-PHY used as DSI byte lane clock source (usual case)"]
    DSI_PHY,
    #[doc = "PLLR used as DSI byte lane clock source, used in case DSI PLL and DSI-PHY are off (low power mode)"]
    PLLR,
}
impl DSISELW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            DSISELW::DSI_PHY => false,
            DSISELW::PLLR => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _DSISELW<'a> {
    w: &'a mut W,
}
impl<'a> _DSISELW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: DSISELW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "DSI-PHY used as DSI byte lane clock source (usual case)"]
    #[inline]
    pub fn dsi_phy(self) -> &'a mut W {
        self.variant(DSISELW::DSI_PHY)
    }
    #[doc = "PLLR used as DSI byte lane clock source, used in case DSI PLL and DSI-PHY are off (low power mode)"]
    #[inline]
    pub fn pllr(self) -> &'a mut W {
        self.variant(DSISELW::PLLR)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 29;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 0:4 - PLLI2S division factor for SAIs clock"]
    #[inline]
    pub fn plli2sdivq(&self) -> PLLI2SDIVQR {
        PLLI2SDIVQR::_from({
            const MASK: u8 = 31;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 8:12 - PLLSAI division factor for SAIs clock"]
    #[inline]
    pub fn pllsaidivq(&self) -> PLLSAIDIVQR {
        PLLSAIDIVQR::_from({
            const MASK: u8 = 31;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 16:17 - PLLSAIDIVR"]
    #[inline]
    pub fn pllsaidivr(&self) -> PLLSAIDIVRR {
        PLLSAIDIVRR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 20:21 - SAI1 clock source selection"]
    #[inline]
    pub fn sai1asrc(&self) -> SAI1ASRCR {
        SAI1ASRCR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 20;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bits 22:23 - SAI1-B clock source selection"]
    #[inline]
    pub fn sai1bsrc(&self) -> SAI1BSRCR {
        SAI1BSRCR::_from({
            const MASK: u8 = 3;
            const OFFSET: u8 = 22;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        })
    }
    #[doc = "Bit 24 - Timers clocks prescalers selection"]
    #[inline]
    pub fn timpre(&self) -> TIMPRER {
        TIMPRER::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 24;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 27 - 48 MHz clock source selection"]
    #[inline]
    pub fn _48msel(&self) -> _48MSELR {
        _48MSELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 27;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 28 - SDIO clock source selection"]
    #[inline]
    pub fn sdiosel(&self) -> SDIOSELR {
        SDIOSELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 28;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 29 - DSI clock source selection"]
    #[inline]
    pub fn dsisel(&self) -> DSISELR {
        DSISELR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 29;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 0:4 - PLLI2S division factor for SAIs clock"]
    #[inline]
    pub fn plli2sdivq(&mut self) -> _PLLI2SDIVQW {
        _PLLI2SDIVQW { w: self }
    }
    #[doc = "Bits 8:12 - PLLSAI division factor for SAIs clock"]
    #[inline]
    pub fn pllsaidivq(&mut self) -> _PLLSAIDIVQW {
        _PLLSAIDIVQW { w: self }
    }
    #[doc = "Bits 16:17 - PLLSAIDIVR"]
    #[inline]
    pub fn pllsaidivr(&mut self) -> _PLLSAIDIVRW {
        _PLLSAIDIVRW { w: self }
    }
    #[doc = "Bits 20:21 - SAI1 clock source selection"]
    #[inline]
    pub fn sai1asrc(&mut self) -> _SAI1ASRCW {
        _SAI1ASRCW { w: self }
    }
    #[doc = "Bits 22:23 - SAI1-B clock source selection"]
    #[inline]
    pub fn sai1bsrc(&mut self) -> _SAI1BSRCW {
        _SAI1BSRCW { w: self }
    }
    #[doc = "Bit 24 - Timers clocks prescalers selection"]
    #[inline]
    pub fn timpre(&mut self) -> _TIMPREW {
        _TIMPREW { w: self }
    }
    #[doc = "Bit 27 - 48 MHz clock source selection"]
    #[inline]
    pub fn _48msel(&mut self) -> __48MSELW {
        __48MSELW { w: self }
    }
    #[doc = "Bit 28 - SDIO clock source selection"]
    #[inline]
    pub fn sdiosel(&mut self) -> _SDIOSELW {
        _SDIOSELW { w: self }
    }
    #[doc = "Bit 29 - DSI clock source selection"]
    #[inline]
    pub fn dsisel(&mut self) -> _DSISELW {
        _DSISELW { w: self }
    }
}
